{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R+,S-,T-,U-,V+,W-,X+,Y-,Z1}
{$H-}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}

Unit _Crypt;
Interface

type
  UserT = String[50];
  PasR = Record
	   name		: UserT;
	   pas		: String[30];
	   paslev	: Byte;
	   iD		: LongInt;
	 end;
  S15 = String[15];
  S30 = String[30];

Function TestPasCrypt(cp : S30; P : S15) : Boolean;
Function NewCryptPas(s : String): String;

Implementation

uses  _Dos;

Var
  buf :String[14];
  {pasrec : pasR;}

Function CString(var s : String) : String;           Forward;
Function PString(var s : String) : String;           Forward;


Function Crypt(pw, salt : ShortString) : String;
Var
  bits      : String;
  i, j, rot : Integer;
  p         : byte;
begin
  pw := CString(pw);
  salt := Cstring(salt);
   For i := 0 to 66 do
    bits[i] := #0;
   if Salt[1] = #0 then
    Salt[1] := char(length(Salt));
  rot := (ord(salt[1]) * 4 - ord(salt[0])) mod 128;
  i := 0;
  p := 0;
   while (i< 8) and (pw[p] <> #0) do
    begin
      for j := 0 to 6 do
      if (ord(pw[p]) and (1 shl j)) <> 0 then bits[i + j * 8] := #1
      else bits[i + j * 8] := #0;
      if (ord(salt[i div 4]) and (1 shl (i mod 4))) <> 0 then bits[i + 56] := #1
      else bits[i + 56] := #0;
     i := i + 1;
     p := p + 1;
    end;
   if (ord(salt[0]) and 1) <> 0 then bits[64] := #1
   else bits[64] := #0;
   if (ord(salt[1]) and 1) <> 0 then bits[65] := #1
   else bits[65] := #0;
   if (rot and 1) <> 0 then bits[66] := #1
   else bits[66] := #1;
   while rot > 0 do
    begin
      rot := rot - 1;
       for i := 65 downto 0 do bits[i+1] := bits[i];
      bits[0] := bits[66];
    end;
   for i := 0 to 11 do
    begin
      buf[i + 2] := #0;
       for j := 0 to 5 do if ord(bits[i * 6 + j]) <> 0 then
       buf[i+2] := chr(ord(buf[i+2]) or (1 shl j))
       else buf[i+2] := chr(ord(buf[i+2]) or 0);
      buf[i+2] := chr(ord(buf[i+2]) + 48);
       if buf[i+2] > '9' then buf[i+2] := chr(ord(buf[i+2]) +7);
       if buf[i+2] > 'Z' then buf[i+2] := chr(ord(buf[i+2]) + 6);
    end;
  buf[0] := Salt[0];
  buf[1] := Salt[1];
  buf[13] := #0;
  Crypt := pString(buf);
end;

Function CString(var s : String) : String;
Var
  ans : String;
begin
  move(s[1], ans[0], ord(s[0]));
  ans[ord(s[0])] := #0;
  CString := ans;
end;

Function NewCryptPas(s : String): String;
Var
  salt  : LongInt;
  sl    : String[2];
  cn    : Integer;
begin
  Salt := time;
  sl[0] := chr((salt and 63) + longint(ord('.')));
  sl[1] := chr(((salt shr 6) and 63) + longint(ord('.')));
  sl[2] := #0;
   for cn := 0 to 1 do
    begin
       if sl[cn] > '9' then inc(sl[cn], 7);
       if sl[cn] > 'Z' then inc(sl[cn],6);
    end;
  NewCryptPas := crypt(s, pString(sl));
end;


Function PString(var s : String) : String;
Var
 ans : String;
 i   : Byte;
begin
  i := 0;
   while s[i] <> #0 do
    begin
      ans[i + 1] := s[i];
      inc(i);
    end;
  ans[0] := chr(i);
  PString := ans;
end;

Function TestPasCrypt(cp : S30; P : S15) : Boolean;
begin
  TestPasCrypt := crypt(p, cp) = cp;
end;

End.
