{$A-,B-,D+,E+,F-,G-,I+,L+,N-,O-,R+,S+,V-,X+}
Unit _Error;
Interface

Const
   Message1	= 'Message';
   Warning	= 'Warning';
   Error	= 'Error';
   Fatal	= 'Fatal Error';

type
  S78	= String[78];
  S8	= String[8];
  ErrorR = Record
	     MDelay1     : Word; {Message}
	     MDelay2     : Word;
	     WDelay1     : Word; {Warning}
	     WDelay2     : Word;
	     EDelay1     : Word; {Error}
	     EDelay2     : Word;
	     FDelay1     : Word; {Fatal error}
	     FDelay2     : Word;
	     MHz         : Word;
	     WHz         : Word;
	     EHz         : Word;
	     FHz         : Word;
	     MFlash      : Boolean;
	     WFlash      : Boolean;
	     EFlash      : Boolean;
	     FFlash      : Boolean;
	   end;
Var
  ErrorRec : ErrorR;

Procedure Message(in1 : S78; in2 :String; in3 : Boolean; in4, in5, in6 : Word);
	  {Put a #10 in the string to split it on to the next line}
Procedure DosE;
Procedure WriteError(e : Word;errorType : S8);

Implementation

uses _Dos, _Code, _Delay;

var
  er : Word;

{Procedure DosE;
Var
  d : String[20];
begin
  d := '';
   if DosError > 1 then
    begin
	case Doserror of
	  0 : ;
	  2 :  d := 'File not found';
	  3 :  d := 'Path not found';
	  5 :  d := 'Access denied';
	  6 :  d := 'Invalid handle';
	  8 :  d := 'Not enough memory';
	  10 : d := 'Invalid environment';
	  11 : d := 'Invalid format';
	  18 : d := 'No more files';
	end;
       if (Doserror > Integer(18)) and
	  (not (Doserror in [Integer(2),3,5,6,8,10,11,18])) then
	  Message(' Error ', 'Unknown dos error', ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1,
		ErrorRec.EDelay2)  else
      Message(' Error '+IntToStr(Doserror), d, ErrorRec.EFlash, ErrorRec.EHz, ErrorRec.EDelay1,
		ErrorRec.EDelay2);
      Doserror := 0;
    end;
end;}

(*Procedure Message(in1 : S78; in2 :String; in3 : Boolean; in4, in5, in6 : Word);
Const dep : Byte = 1;
var
  oldTextAttr, len, OldCursorAttr	: Byte;
  tempS, tempS2	:S78;
begin
  Flush;
   if (in4 = 0) and (in5 = 0) and (in6 = 0) then Exit;
  OldCursorAttr := GetCursorAttr;
  SetCursorAttr(Invisable);
  oldTextAttr := TextAttr;
   if TextAttr >= 128 then TextAttr := TextAttr - 128;
   if in3 = True then TextAttr := TextAttr + 128;
  len := Length(in2) + 2;
  dep := 1;
{   if len > 78 then
    begin
      dep := len div 78;
       if len mod 78 > 0 then inc(dep);
      len := 78;
       if dep > GetScreenRows - 2 then dep := GetScreenRows - 2;
    end
    else} begin
     tempS := in2;
     dep := 1;
     len := 1;
       while InString(tempS, #10) do
	begin
	  dep := dep + 1;
	   tempS2 := SplitK2(tempS, #10);
	    if len+2 < Length(tempS2) then len := Length(tempS2) + 2;
	end;
       if len+2 < Length(tempS) then len := Length(tempS) + 2;
    end;
   if Byte(in1[0]) > len then len := Length(in1) + 1;
  CenterWindow(len, dep, 0, in1);
  if InOutError then WriteError(GetLastInOutError, Warning);
  GotoXY(1,1);
   while InString(in2, #10) do WriteLn(TruncateTo(SplitK2(in2, #10), 78));
  Write(' ', in2);
  NoSound;
   if in4 > 1 then Sound(in4);
  Delay(in5);
  NoSound;
  Delay(in6);
   if (in6 = 0) and (in5 = 0) then
    begin
      Flush;
      KeyLoop;
    end;
  RemoveWindow(0, 0);
  TextAttr := oldTextAttr;
  SetCursorAttr(OldCursorAttr);
end;*)

{Procedure WriteError(e : Word;  errorType : S8);
Const
  s : String = '';
  width : Byte = 0;
  Depth : Byte = 0;
var
  id :Word;
begin
   if GetLineLength < 25 then RunError(534);
  s := ErrorCode(e);
  depth := Length(s) div (GetLineLength - 2);
  inc(depth);
   if depth > 1 then width := GetLineLength - 2
   else width := Length(s) + 3;
   if width < 8 then width := 8;
  id := CenterWindow(width, depth, 0, errorType);
   if InOutError then
    begin
      Cls(1, 1, GetLineLength, GetScreenRows, 0, 'E', TextAttr);
      DrectWriteS(2, 1, 0, s);
    end
    else begin
      GotoXY(2, 1);
      write(s);
      RemoveWindow(0, 0);
    end;
end;

BEGIN
  ErrorRec.MDelay1       := 1000;
  ErrorRec.MDelay2       := 3000;
  ErrorRec.WDelay1       := 1000;  {Warning}
  ErrorRec.WDelay2       := 2000;
  ErrorRec.EDelay1       := 2000;  {Error}
  ErrorRec.EDelay2       := 2000;
  ErrorRec.FDelay1       := 2000;
  ErrorRec.FDelay2       := 2000;
  ErrorRec.MHz           := 700;
  ErrorRec.WHz           := 1000;
  ErrorRec.EHz           := 1500;
  ErrorRec.FHz           := 2000;
  ErrorRec.MFlash        := False;
  ErrorRec.WFlash        := True;
  ErrorRec.EFlash        := False;
  ErrorRec.FFlash        := True;
END.