{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U+,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$WARN SYMBOL_DEPRECATED ON}
{$WARN SYMBOL_LIBRARY ON}
{$WARN SYMBOL_PLATFORM ON}
{$WARN UNIT_LIBRARY ON}
{$WARN UNIT_PLATFORM ON}
{$WARN UNIT_DEPRECATED ON}
{$WARN HRESULT_COMPAT ON}
{$WARN HIDING_MEMBER ON}
{$WARN HIDDEN_VIRTUAL ON}
{$WARN GARBAGE ON}
{$WARN BOUNDS_ERROR ON}
{$WARN ZERO_NIL_COMPAT ON}
{$WARN STRING_CONST_TRUNCED ON}
{$WARN FOR_LOOP_VAR_VARPAR ON}
{$WARN TYPED_CONST_VARPAR ON}
{$WARN ASG_TO_TYPED_CONST ON}
{$WARN CASE_LABEL_RANGE ON}
{$WARN FOR_VARIABLE ON}
{$WARN CONSTRUCTING_ABSTRACT ON}
{$WARN COMPARISON_FALSE ON}
{$WARN COMPARISON_TRUE ON}
{$WARN COMPARING_SIGNED_UNSIGNED ON}
{$WARN COMBINING_SIGNED_UNSIGNED ON}
{$WARN UNSUPPORTED_CONSTRUCT ON}
{$WARN FILE_OPEN ON}
{$WARN FILE_OPEN_UNITSRC ON}
{$WARN BAD_GLOBAL_SYMBOL ON}
{$WARN DUPLICATE_CTOR_DTOR ON}
{$WARN INVALID_DIRECTIVE ON}
{$WARN PACKAGE_NO_LINK ON}
{$WARN PACKAGED_THREADVAR ON}
{$WARN IMPLICIT_IMPORT ON}
{$WARN HPPEMIT_IGNORED ON}
{$WARN NO_RETVAL ON}
{$WARN USE_BEFORE_DEF ON}
{$WARN FOR_LOOP_VAR_UNDEF ON}
{$WARN UNIT_NAME_MISMATCH ON}
{$WARN NO_CFG_FILE_FOUND ON}
{$WARN MESSAGE_DIRECTIVE ON}
{$WARN IMPLICIT_VARIANTS ON}
{$WARN UNICODE_TO_LOCALE ON}
{$WARN LOCALE_TO_UNICODE ON}
{$WARN IMAGEBASE_MULTIPLE ON}
{$WARN SUSPICIOUS_TYPECAST ON}
{$WARN PRIVATE_PROPACCESSOR ON}
{$WARN UNSAFE_TYPE ON}
{$WARN UNSAFE_CODE On}
{$WARN UNSAFE_CAST ON}
unit _LongIntegers;

interface
uses Math;
const
  OneBitLessThan32 = $7FFFFFFF; //2^31
  Bits32	   = $FFFFFFFF; //2^32
  Bit32		   = $80000000;
type
  TSign = Integer;	//(positive = 1, negitive = -1);  but any value < 0 will be taken to be negitive.
  TInt = array of LongWord;	//The first element is the least significant
				//with the value given by element[x]*$10^(x*8)
  TLongInt = record
    int: TInt;
    sign: Integer;	//-1 for negative, 1 for positive
  end;
  st = record
	val:string;
	op:string;
  end;

function SubI(const n,n2:TInt; var sign:Integer):TInt;	overload;
function SubI(const n,n2:TInt):TLongInt;		overload;
function SubI(const n,n2:TLongInt):TLongInt;		overload;
procedure DecI(var n1:TLongInt);

Function AddI(const n,n2:TLongInt): TLongInt;
Function DivI(const Dividend, divisor:TLongInt; var r:TLongInt): TLongInt;
Function MulI(const n,n2:TLongInt): TLongInt;		Overload;
Function MulI(const n1:TLongInt;n2:LongInt): TLongInt;	Overload;

procedure TruncI(var n1:TLongInt;len:LongWord);

Function AddL(const n,n2:TInt): TInt;
Procedure AddLAt(var n, n2:TInt; x:LongWord = 0);
//set x to 0 for the first element
Procedure AddIAt(var n:TInt; n2:LongWord; x:LongWord = 0);
Function MulL(const n, n2:TInt): TInt;		Overload;
Function MulL(const n:TInt;n2: LongWord): TInt;	Overload;
Function CompL(const n1,n2:TInt): Integer;	   overload;
Function CompL(const n1:TInt;n2:Longword): Integer;overload;
Function CompL(const n1,n2:TLongInt): Integer;	   overload;
Function CompL(const n1:TLongInt;n2:LongInt): Integer;overload;
Function CompLZ(const n :TInt):Boolean ;
Function SubL(const n1, n2:TInt):TInt;	      overload; //n1 must be >= n2.
function SubL(const n1:TInt;n2:Longword):TInt; overload; //n1 must be >= n2.
Function DivIL(const n:TInt; n2: LongWord; var r: LongWord): TInt;
Function DivL(const Dividend, divisor:TInt; var Remainder: TInt): TInt; pascal Overload;
Function DivL(const Dividend, divisor:TInt): TInt; Overload;
Procedure ZeroNL(const n:Tint);
Function LengthUsed(const n:TInt): LongWord;
Function LengthUsedInBits(const n:TInt):LongWord ;
Function BitsUsed(i:LongWord):byte;
Function DivUp(const n1,n2:LongWord):LongWord;

procedure _AddL(const n,n2:TInt;const l2:LongWord);
//n is the result so must be the longest & long enough for the result with any carry;
Procedure _AddLAt(const n,n2:TInt; l2:LongWord; x:LongWord = 0); Register;
//n is the result so must be the longest & long enough for the result with any carry;
Procedure _SubL(const n1:TInt{eax};n2:Longword{edx}); Register; Overload;
//n1 must be >= n2. result is given in n1
//length(n1) >= 1
Procedure _SubL(const n1,n2:TInt;l2:Longword); Register; Overload;
//n1 must be >= n2 & l2 length of n2. result is given in. n1 l2 >= 1;
Procedure _AddIAt(const n:Tint; n2:LongWord; x:LongWord = 0);
//warning n MUST point to an array big enough to fit the answer in when called.
procedure _MulL(const n, n2,result1:TInt;const l,l2:LongWord); Register Overload;
//warning result MUST be a zeroed array big enough to fit the result in when called.
procedure _MulL(const n:TInt;const n2, l:LongWord); Register Overload;
//warning n MUST be big enough to fit the result in when called with any extra space zeroed
Procedure _DivL(const Dividend, divisor, Remainder:TInt;
	    DividendLen, divisorLen, divisorLenBits:LongWord);		overload; register;
Function _DivL(const n:TInt; n2,l: LongWord): LongWord; register;	overload
Function _LengthUsedInBits(const n:TInt;l:LongWord):LongWord;
Function _ShiftLeftL(const n:TInt;l:LongWord):Boolean; //returns true if there is a carry
Procedure Shunt32(var n1:TInt);//n1 * 2^32


implementation
uses _Mem;
Function PadToL(var n:TInt; x:LongWord):Integer; Forward;

Procedure Shunt32(var n1:TInt);//n1 * 2^32
var
  lU,x:LongWord;
begin
  lU := LengthUsed(n1);
  if lu = LongWord(length(n1)) then setLength(n1,lU+1);
  for x := lU downto 1 do n1[x] := n1[x-1];
  n1[0] := 0;
end;

procedure TruncI(var n1:TLongInt;len:LongWord);
var
  lU,x: LongWord;
begin
  if LongWord(length(n1.int)) <= len then exit;
  lU := LengthUsed(n1.int);
  if lU <= len then SetLength(n1.int,LU)
  else begin
    for x := 0 to len-1 do n1.int[(len-1)-x] := n1.int[(lU-1) - x];
    SetLength(n1.int,len);
  end;
end;


function SubI(const n,n2:TInt; var sign:Integer):TInt; overload;
//sign returns the sign of the answer only
begin
  if CompL(n, n2) >= 0 then
  begin
    result := SubL(n,n2);
    sign := 1;
  end
  else begin
    result := SubL(n2, n);
    sign := -1;
  end;
end;

function SubI(const n,n2:TInt):TLongInt; overload;
begin
  result.int := SubI(n,n2,result.sign);
end;

function SubI(const n,n2:TLongInt):TLongInt; overload;
begin
  if (n.sign = -1) and (n2.sign = -1) then
  begin
    result := SubI(n2.int, n.int)
  end
  else if (n.sign = -1) and (n2.sign <> -1) then
  begin
    result.int := AddL(n.int, n2.int);
    result.sign := -1;
  end
  else if (n.sign <> -1) and (n2.sign = -1) then
  begin
    result.int := AddL(n.int,n2.int);
    result.sign := 1;
  end
  else begin
    result := SubI(n.int, n2.int)
  end;
end;

Function AddI(const n,n2:TLongInt): TLongInt;
begin
  if (n.sign = -1) and (n2.sign = -1) then
  begin
    result.int := AddL(n2.int, n.int);
    result.sign := -1
  end
  else if (n.sign = -1) and (n2.sign <> -1) then
  begin
    result := SubI(n2.int, n.int);
  end
  else if (n.sign <> -1) and (n2.sign = -1) then
  begin
    result := SubI(n.int,n2.int);
  end
  else begin	//both positive
    result.int := AddL(n.int, n2.int);
    result.sign := 1;
  end;
end;

Function DivI(const Dividend, divisor:TLongInt; var r:TLongInt): TLongInt;

begin
  result.int := DivL(Dividend.int,divisor.int,r.int);
  r.sign := Dividend.sign;
  result.sign := Dividend.sign;
  if divisor.sign = -1 then result.sign := result.sign * -1;
end;

Function MulI(const n1:TLongInt;n2:LongInt): TLongInt;	Overload;
var
  t:TLongInt;
begin
  if n2 < 0 then
  begin
    t.sign := -1;
    n2 := n2 * (-1);
  end
  else t.sign := 1;
  SetLength(t.int,1);
  t.int[0] := n2;
  result := MulI(n1,t);
end;

Function MulI(const n,n2:TLongInt): TLongInt;
begin
  result.int := MulL(n.int,n2.int);
  result.sign := n.sign;
  if n2.sign = -1 then result.sign := result.sign * -1;
end;

Function MulL(const n:TInt;n2: LongWord): TInt; Overload;
var
  t:TInt;
begin
  Setlength(t,1);
  t[0] := n2;
  result := MulL(n,t);
end;

Procedure ZeroNL(const n:Tint);
begin
  if length(n) >= 1 then {$WARN UNSAFE_CODE Off}
    SetMem32(addr(n[0]), length(n)); {$WARN UNSAFE_CODE On}
end;

Function LengthUsed(const n:TInt): LongWord;
var
  x: LongWord;
begin
  x:= length(n);
  if x < 1 then
  begin
    result := 0;
    exit;
  end;
  dec(x);
  for x := x downTo 0 do
    if n[x] <> 0 then
    begin
      result := x+1;
      exit;
    end;
  result := 0;
end;

Function _LengthUsedInBits(const n:TInt;l:LongWord):LongWord;
var
  x: LongWord;
begin
  result := 0;
  if l < 1 then
  begin
    result := 0;
    exit;
  end;
  dec(l);
  for x := l downTo 0 do
    if n[x] <> 0 then
    begin
      result := x+1;
      break;
    end;
  if result > 0 then result := ((result-1) * 32) + BitsUsed(n[result-1]);
end;


Function LengthUsedInBits(const n:TInt):LongWord;
begin
  result := _LengthUsedInBits(n,length(n));
end;

Function BitsUsed(i:LongWord):byte;
begin
  result := 0;
  while i > 0 do
  begin
    inc(result);
    i := i shr 1;
  end;
end;

Function CompLZ(const n :TInt):Boolean ;
begin
  result := LengthUsed(n) = 0;
end;

Function CompL(const n1:TInt;n2:Longword): Integer;
var
  t: TInt;
begin
  SetLength(t,1);
  t[0] := n2;
  result := CompL(n1,t);
end;

Function CompL(const n1,n2:TInt): Integer;
var
  x, y :LongWord;
begin
  if n1=n2 then
  begin
    result := 0;
    exit;
  end;
  x := LengthUsed(n1);
  y := LengthUsed(n2);
  if x > y then result := 1
  else if x < y then result := -1
  else if x = 0 then result := 0
  else begin
    result := 0;
    for x := y-1 downTo 0 do
    begin
      if n1[x] > n2[x] then
      begin
	 result := 1;
	 break;
      end
      else if n1[x] < n2[x] then
      begin
	 result := -1;
	 break;
      end
    end;
  end;
end;

Function CompL(const n1,n2:TLongInt): Integer;	   overload;
begin
  if (n1.sign >= 0) and (n2.sign >= 0) then result := CompL(n1.int,n2.int)
  else if (n1.sign < 0) and (n2.sign < 0) then result := CompL(n1.int,n2.int) * -1
  else if (n1.sign < 0) then
  begin
    if CompL(n1.int,n2.int) = 0 then result := 0
    else result := -1;
  end
  else begin
    if CompL(n1.int,n2.int) = 0 then result := 0
    else result := 1;
  end;
end;

Function CompL(const n1:TLongInt;n2:LongInt): Integer;overload;
var
  t: TLongInt;
begin
  SetLength(t.int,1);
  if n2 < 0 then
  begin
    t.int[0] := -n2;
    t.sign := -1;
  end
  else begin
    t.int[0] := n2;
    t.sign := 1;
  end;
  result := CompL(n1,t);
end;

Function PadToL(var n:TInt; x:LongWord):Integer;
var
  t:LongWord;
begin
  t := length(n);
  if x <= t then
  begin
    result := t;
    exit;
  end;
  SetLength(n,x);
  {$WARN UNSAFE_CODE Off}
  SetMem32(addr(n[t]), x-t);{$WARN UNSAFE_CODE On}
  result := x
end;

Procedure _SubL(const n1:TInt{eax};n2:Longword{edx}); Register;
//n1 must be >= n2. result is given in n1
//length(n1) >= 1
{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
    sub		[eax], edx //Sub the 2ed input from the 1st
    jnc		@end            //When no carry jump to end
    mov		ecx, 1
@loop2:
    sub		[eax+ecx*4], 1
    inc		ebx
    jc		@loop2
@end:
end;

Procedure _SubL(const n1,n2:TInt;l2:Longword); Register;
//n1 must be >= n2 & l2 length of n2. result is given in n1
//l2 must be >= 1
{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE ON}
    push 	edi
    push	ebx
    mov		edi, eax
    sub		ebx, ebx	//clear the EbX reg and clears the CF
    jecxz	@end// help! error
@loop1:  		   	//Sub the 2ed input from the 1st utill the 2ed runs out
    mov		eax, [edx+ebx*4]
    sbb  	[edi+ebx*4], eax
    inc		ebx
    loop	@loop1
@endSub:	       		//Now sub any remianing carry from the 1st input
    jnc		@end            //When no carry jump to end
@loop2:
    sub		[edi+ebx*4], 1
    inc		ebx
    jc		@loop2
@end:				//Restor registers
    pop		ebx
    pop		edi
end;

Procedure DecI(Var n1:TLongInt);
begin
  if compLZ(n1.int) then
  begin
    SetLength(n1.int,1);
    n1.int[0] := 1;
    n1.sign := -1;
  end
  else if n1.sign < 0 then
  begin
    AddIAt(n1.int, 1);
  end
  else _SubL(n1.int, 1);
end;

{function DecI(const n1:TLongInt):TLongInt;
begin
  if compLZ(n1.int) then
  begin
    SetLength(result.int,1);
    result.int[0] := 1;
    result.sign := -1;
  end
  else if n1.sign < 0 then
  begin
    result := copy(n1);
    AddIAt(.int, 1);
    result.sign := n1.sign;
  end
  else result := SubL(n1,1);
end;}

function SubL(const n1:TInt;n2:Longword):TInt; overload;
//n1 must be >= n2.
var
  n3:TInt;
begin
  setLength(n3,1);
  n3[0] := n2;
  result := SubL(n1,n3);
end;

function SubL(const n1,n2:TInt): TInt;
//n1 must be >= n2.
var
  c:Integer;
  l2:LongWord;
begin
  l2 := LengthUsed(n2);
  if l2 = 0 //need only check y as x >= y (checked below)
  then begin
    result := n1;
    exit;
  end;
  c := compL(n1,n2);
  if c < 0 then
  begin		//error precondition not satisfied
    result := SubL(n2,n1);
    exit;
  end;
  if c = 0 then
  begin
    SetLength(result,1);
    result[0] := 0;
    Exit;
  end;
  _SubL(n1,n2,l2);
  result := n1;
end;

Procedure _AddIAt(const n:TInt; n2:LongWord; x:LongWord = 0); Register;{$WARN UNSAFE_CODE Off}
//warning n MUST be big enough to fit the answer in when called.
//n is not checked for nil
//n can be any array of 32 bit elements
//set x to 0 for the first element
// with register n is eax, n2 is edx & x is in ecx
asm{$WARN UNSAFE_CODE On}
    cmp		edx,0		//if n2 = 0 then exit;
    je		@End
    add		[eax+ecx*4], edx// n[x] := n[x] + n2 (all on this line)
@loop1:                         //Now add in any carry left over
    jnc		@end            //When no carry jump to end;
    inc		ecx          //goto next element
    add		[eax+ecx*4], 1
    jmp		@loop1
@end:				//Restor registers
end;

Procedure _AddLAt(const n,n2:TInt; l2:LongWord; x:LongWord = 0); Register;{$WARN UNSAFE_CODE Off}
//warning n MUST be big enough to fit the answer in when called.
//n is not checked for nil
//n can be any array of 32 bit elements
//set x to 0 for the first element
// with register n is eax, n2 is edx & l2 is in ecx
//n,n2 are used as pointers to arrays
asm{$WARN UNSAFE_CODE On}
  shl	x, 2
  add	eax, x
  call	_AddL
end;

Procedure AddLAt(var n, n2:TInt; x:LongWord = 0);
//set x to 0 for the first element
var
  t,lu:LongWord;
begin
  if CompLZ(n2) then exit;
  t := length(n);
  lu := LengthUsed(n2);
  if x + lu > t then
  begin
    if n2[lu-1] > OneBitLessThan32 then PadToL(n, x+lu+1)
    else PadToL(n, x+lu);
  end
  else if n[t-1] <> 0 then
  begin
    if lu+x < t then
    begin
      if bits32 = n[t-1] then PadToL(n, t+1);
    end
    else if (bit32 <= n[t-1]) or (bit32 <= n2[lu-1]) then PadToL(n, t+1);
  end;
  _AddLAt(n,n2,lu,x);
end;

Procedure AddIAt(var n:TInt; n2:LongWord; x:LongWord = 0);
//set x to 0 for the first element
var
  t:LongWord;
begin
  if n2 = 0 then exit;
  t := length(n);
  if x+1 > t then
  begin
    PadToL(n, x+1);
    n[x] := n2;
    exit;
  end;
  if n[t-1] <> 0 then
  begin
    if x = t-1 then
    begin
      if (bits32 - n[t-1]) < n2 then PadToL(n, t+1);
    end
    else if n[t-1] = bits32 then PadToL(n, t+1);
  end;
  _AddIAt(n,n2,x);
end;

procedure _AddL(const n,n2:TInt;const l2:LongWord);
//n is the result so must be the longest & long enough for the result with any carry;
//n,n2 are used as pointers to arrays
{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
    push 	ebx
    push	edi
    mov		edi, eax	//set edi to point to n[0]
    sub		ebx,ebx		//zero ebx & clear CF
    jecxz	@end		//Help! error
@loop1:  		   	//Add the two inputs together utill one runs out
    mov     	eax, [edx+ebx*4]
    adc     	[edi+ebx*4], eax
    inc		ebx
    loop	@loop1		//ecx is l2; the length of n2 the shortest number

    jnc		@end            //When no carry goto end;
@loop2:                         //Now add in any carry
    add     	[edi+ebx*4], 1
    inc         ebx
    jc		@loop2
@end:				//Restor registers
    pop		edi
    pop		ebx
end;

Function AddL(const n,n2:TInt): TInt;
var
  x,y:LongWord;
begin
  x := LengthUsed(n);
  y := LengthUsed(n2);
  if y > x then
  begin			//Make sure x >= y.
    result := AddL(n2,n);
    exit;
  end;
  if y = 0 then
  begin
    result := n;
    exit;
  end;
  if x = 0 then
  begin			//As we have allready made sure x >= y both
    result := nil;	//x & y have 0 used length.
    exit;
  end;
  result := n;
  if (x > y) and (n[x-1] = bits32) and (longWord(length(n)) <= x)then
  begin
    SetLength(result,x+1);
    n[x] := 0;
  end
  else begin
    if ((n2[y-1] > OneBitLessThan32) or (n[x-1] > OneBitLessThan32))
       and (longWord(length(n)) <= x) then
    begin
      SetLength(result,x+1);
      n[x] := 0;
    end
    else SetLength(result,longWord(length(result)));
  end;
  _AddL(result,n2,y);
end;

procedure ReverseL(n:TInt);
var
  x, t, L, L2: LongWord;
begin
  L := LengthUsed(n);
  if L < longWord(length(n)) then SetLength(n, L);
  if L < 2 then exit;
  L2 := L div 2;
  dec(L2);
  dec(L);
  for x := 0 to (L2) do
  begin
    t := n[x];
    n[x] := n[L-x];
    n[L-x] := t;
  end;
end;


Function DivIL(const n:TInt; n2: LongWord; var r: LongWord): TInt;
//return the quotient & set r to the remaider
var
  x:LongWord;
begin
  x := LengthUsed(n);
  result := n;
  SetLength(result, x);
  r := _DivL(result,n2,x);
end;

Function _DivL(const n:TInt; n2,l: LongWord): LongWord; register; {$WARN UNSAFE_CODE Off}
//set n to the quotient & return the remaider
asm{$WARN UNSAFE_CODE On}
  cmp	edx,0
  je	@end2
  cmp	ecx,0
  jne	@SRetZ
@retZ:
  xor	eax,eax
  jmp	@End2
@SRetZ:
  push	ebx
  push	esi
  mov	esi, eax
  mov	ebx, edx
  sub	esi, 4	//as we have a 0 indexed array and ecx gos down to 1
  xor	edx, edx	//set the high word used by div to 0
@loop1:
  mov	EAX, [esi+ecx*4]  //set the low word to n[x]
  div	ebx
  mov	[esi+ecx*4], EAX
  loop	@loop1
  mov	eax, edx
  pop	esi
  pop	ebx
@end2:
end;

Function _ShiftLeftL(const n:TInt;L:LongWord):Boolean; Register;{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
  mov	ecx, edx
  clc			//clear carry flag else could return true with empty array
  jecxz	@end		//if array empty goto end
  dec	ecx;		//dec as the first element is done before the loop
  shl	[eax], 1
  jecxz	@end
  mov   edx, 0
@loop:
  inc	edx
  rcl	[eax+edx*4], 1
  loop	@loop
@end:
  mov	eax, 0
  adc	eax, 0
end;


Function ShiftLeft32L(n:TInt;n2: LongWord): TInt;
//return the answer
var
  x:LongWord;
begin
  If n2 = 0 then
  begin
    result := n;
    exit;
  end;
  SetLength(result,n2+longWord(length(n)));
  for x := n2 to length(result)-1 do result[x] := n[x-n2];{$WARN UNSAFE_CODE Off}
  SetMem32(addr(result[0]),n2);{$WARN UNSAFE_CODE On}
end;

Function DivL(const Dividend, divisor:TInt): TInt; Overload;
var
  r:Tint;
begin
  result := DivL(Dividend, divisor, r);
end;

Function DivL(const Dividend, divisor:TInt; var Remainder: TInt): TInt; Overload;
var
  DividendLen, divisorLen, divisorLenBits : LongWord;
  comp:Integer;
begin
  DividendLen := LengthUsed(Dividend);
  divisorLenBits := LengthUsedInbits(divisor);
  divisorLen := DivUp(divisorLenBits,32);
  if divisorLen = 1 then
  begin
    SetLength(Remainder, 1);
    result := DivIL(Dividend,divisor[0],Remainder[0]);
    exit;
  end;
  if DividendLen < 1 then
    begin Remainder:=nil; result:=nil; exit; end;
  if (DividendLen = 1) and (Dividend[0] = 0) then
    begin Remainder:= Dividend; result := Remainder; exit; end;
  if divisorLen < 1 then
  begin		//error divide by 0
    Remainder := nil; result := nil; exit;
  end;
  comp := CompL(Dividend,divisor);
  if comp = -1 then
  begin
    Remainder := Dividend;
    SetLength(result,1);
    result[0] := 0;
    exit;
  end
  else if comp = 0 then
  begin
    Remainder := nil;
    SetLength(result,1);
    result[0] := 1;
    exit;
  end;
  SetLength(Remainder, DivUp(divisorLenBits+1,32));
  ZeroNL(Remainder);
  result := copy(Dividend);	//Set quotient to = dividend so we can shift them at the same time the dividend will be shifted out and we will be left with the answer
  _DivL(Result,divisor,remainder,DividendLen,divisorLen,divisorLenBits);
end;

Procedure _DivL(const Dividend, divisor, Remainder:TInt;
	    DividendLen, divisorLen, divisorLenBits:LongWord); Register;
//RemainderLenBits should be at least divisorLenBits + 1 & they nead to be zeroed
//Dividend is the Quotient when finished
//Arrays must be setup before calling
//don't call with divisor <= 1
//  label LbitsZ;
var
  x, lRbits: LongWord;
begin
  //Quotient = Dividend;	//Set quotient to = dividend so we can shift them at the same time the dividend will be shifted out and we will be left with the answer
  lRbits := 0;
  x:=1;
  repeat
//  LbitsZ:
    while (x <= DividendLen * 32) {and (lRbits = 0)} do
    begin
      if _ShiftLeftL(Dividend,DividendLen) then
      begin // shift Quotient left 1
	Remainder[0] := Remainder[0] or 1; //move the shifted bit from Quotient(as Dividend) to Remainder if any
	lRbits := 1;
	inc(x);
	break;
      end;
      inc(x);
    end;
  //if Divisor could = 1 (ie. the precondition is not folowed) would nead to check for Remainder >= Divisor here
    while  (x <= DividendLen * 32) and (lRBits <> 0) do
    begin
      _ShiftLeftL(Remainder, (lRbits div 32)+1);     // shift left Remainder:Quotient by 1(Remainder this line)
      if _ShiftLeftL(Dividend,DividendLen) then // shift Quotient left 1
	Remainder[0] := Remainder[0] or 1; //move the shifted bit from Quotient(as Dividend) to Remainder if any
      inc(x);
      Inc(lRbits);
      if (lRbits >= divisorLenBits) then		//if Remainder >= Divisor
	if ((lRbits = divisorLenBits) and (CompL(Remainder, Divisor) >= 0))
	or (lRbits > divisorLenBits) then
	begin
	  _SubL(Remainder, Divisor,divisorLen);
	  lRbits := _LengthUsedInBits(Remainder,DivUp(divisorLenBits+1,32));
	  Dividend[0] := Dividend[0] or 1; //(Dividend as Quotient) add 1 to Quotient (as it has been shl above we know bit 1 is clear)
  //	if lRBits = 0 then goto LbitsZ
	end;
    end;
  until (x > DividendLen * 32)
end;

Function MulL(const n, n2:TInt): TInt; Overload
//return the answer
var
  L, L2, lB1, lB2: LongWord;
begin
  lB1 := LengthUsedInBits(n);
  lB2 := LengthUsedInBits(n2);
  L := divUp(lb1,32);
  L2 := divUp(lb2,32);
  if (L2 = 0) or (L = 0) then
  begin
    result := nil;
    exit;
  end;
  lb1 := divUp(lB1+lB2,32);
  SetLength(result,lb1);
//  ZeroNL(Remainder);
  _MulL(n,n2,result,l,l2);
end;

procedure _MulL(const n:TInt;const n2, l:LongWord); Register Overload;
//warning n MUST be big enough to fit the answer in when called.
//return the answer
var
  x, y: LongWord;
  t:TInt;                 {$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
  cmp	l, 0	//if L2 = 0 then exit;
  je	@end2
  push	edi
  push	esi
  push	ebx
  mov	ebx,edx
  mov	edi, eax
@loop2:
  jecxz	@end1
  dec	ecx
  mov	eax, [edi+ecx*4]//  m1 := n2[x];
  xor   [edi+ecx*4],eax	//zero the curent element of the array after we have the value out
  mul	ebx
  mov	esi,ecx		//save ecx _AddIAt(n,m1,x+y);
  cmp	edx,0		//add in the caried part?
  je	@s1
  push	eax		//_AddIAt(n,m2,x+y+1)
  mov	eax,edi
  inc	ecx
  call	_AddIAt
  pop	eax
  mov	ecx,esi
  @s1:
  mov	edx,eax		//setup m1
  mov	eax, edi	//setup n
  call	_AddIAt
  mov	ecx,esi
  jmp	@loop2
  @end1:
  pop   ebx
  pop	esi
  pop	edi
  @end2:
end;

procedure _MulL(const n, n2,result1:TInt;const l,l2:LongWord); Register
//warning n MUST be big enough to fit the answer in when called.
//return the answer
var
  x, y: LongWord;
  t:TInt;{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
  cmp	l, 0	//if L2 = 0 then exit;
  je	@end2
  cmp	l2, 0	//if l2 = 0 then exit;
  je	@end2

  push	edi
  push	esi
  push	ebx
  mov	edi, eax
  mov	esi, edx
  mov	t, ecx
//  for y := L1-1 downto 0 do
@loop1:
  mov	ecx, l
  jecxz	@end1
  dec	ecx
  dec	l
  mov	ebx,[edi+ecx*4]
  cmp	ebx, 0		//if n[y] = 0 then continue;
  je	@loop1
  mov	ecx, l2
    @loop2:
    //  if n2[x] = 0 then continue;
    jecxz	@loop1
    dec		ecx
    mov		eax, [esi+ecx*4]//  m1 := n2[x];
    cmp		eax,0
    je		@loop2
    mul		ebx
    mov		x,ecx
    cmp		edx,0		//add in the caried part?
    je		@s1
				//_AddIAt(n,m2,x+y+1)
    push	eax
    mov		eax,t
    add		ecx,l
    inc		ecx
    call	_AddIAt
    pop		eax
    mov		ecx,x
  @s1:
    mov		edx,eax		//setup m1
    add		ecx,l	        //setup x+y in ecx
    mov		eax, t	//setup n
    call	_AddIAt
    mov		ecx,x
    jmp		@loop2
  @end1:
  pop   ebx
  pop	esi
  pop	edi
  @end2:
end;


Function DivUp(const n1,n2:LongWord):LongWord; Register;{$WARN UNSAFE_CODE Off}
asm{$WARN UNSAFE_CODE On}
  mov	ecx,edx
  xor	edx,edx
  div	ecx
  cmp	edx,0
  je	@s1
  inc	eax
@s1:
end;


begin
//  SetLength(TInt1.int,1);
//  TInt1.int[0] := 1;
//  TInt1.sign := 1;
end.
