unit Option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ConstDef;

type
  TOptionForm = class(TForm)
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    BitBtn1: TBitBtn;
    OkBitBtn: TBitBtn;
    SoundGroup: TGroupBox;
    ShowWordCheckBox: TCheckBox;
    ReShowWordCheckBox: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure OkBitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionForm: TOptionForm;

implementation

{$R *.DFM}

procedure TOptionForm.FormShow(Sender: TObject);
begin
   if inOrder then RadioGroup1.ItemIndex := 0
   else RadioGroup1.ItemIndex := 1;
   if doFile then RadioGroup2.ItemIndex := 0
   else RadioGroup2.ItemIndex := 1;
   ShowWordCheckBox.Checked := ShowIfWave;
   ReShowWordCheckBox.Checked := ReshowIfWave;
end;

procedure TOptionForm.OkBitBtnClick(Sender: TObject);
begin
   if RadioGroup1.ItemIndex = 0 then inOrder := True;
   if RadioGroup1.ItemIndex = 1 then inOrder := False;
   if RadioGroup2.ItemIndex = 0 then doFile := True;
   if RadioGroup2.ItemIndex = 1 then doFile := False;
   ShowIfWave := ShowWordCheckBox.Checked;
   ReshowIfWave := ReShowWordCheckBox.Checked;
end;

end.
