{$A-,B-,D+,E+,F-,G-,I+,L+,N+,O-,R-,S+,V-,X-}
{$M 16384,0,655360}
{$M 20384,0,100}
uses Crt, dos,printer;
const
  bs   = #8;     home   = #0#71;
  esc  = #27;    left   = #0#75;   alta = #0#30;  altn = #0#49;
  ret  = #13;    right  = #0#77;   altb = #0#48;  alto = #0#24;
  tab  = #9;     up     = #0#72;   altc = #0#46;  altp = #0#25;
  stab = #0#15;  down   = #0#80;   altd = #0#32;  altq = #0#16;
  f1   = #0#59;  end1   = #0#79;   alte = #0#18;  altr = #0#19;
  f2   = #0#60;  pgup   = #0#73;   altf = #0#33;  alts = #0#31;
  f4   = #0#62;  pgdn   = #0#81;   altg = #0#34;  altt = #0#20;
  f5   = #0#63;  ins    = #0#82;   alth = #0#35;  altu = #0#22;
  f6   = #0#64;  del    = #0#83;   alti = #0#23;  altv = #0#47;
  f7   = #0#65;  cleft  = #0#115;  altj = #0#36;  altw = #0#17;
  f8   = #0#66;  cright = #0#116;  altk = #0#37;  altx = #0#45;
  f9   = #0#67;  cpgup  = #0#132;  altl = #0#38;  alty = #0#21;
  f10  = #0#68;  cpgdn  = #0#118;  altm = #0#50;  altz = #0#44;

const
  lf   = #13#10;
  ds   = #186;
  CND12 = #27'!'#5#27'x'#0;
  UN1 = #27'-'#1; { SELECTS CUNTINUOUS UNDRTLINING}
  UN0 = #27'-'#0; { CANCELS CUNTINUOUS UNDRTLINING}
  LPI = #27#0;   { 8 LINES PRT INCH}
type
S12  = String[12];
S60  = String[60];
S30  = String[30];
S175 = String[175];
key  =  string[2];
GP    = Array[3..6] of S60;
GGP   = Array[7..14] of S60;
GGGp  = Array[15..30] of S60;
GGGGp = Array[31..62] of S60;
FDun  = Array[0..5] of Boolean;

star = Record
         f     : S12;
         field : Byte;
       end;

SD   = Record
         KCR     : Array[1..2] of String[15];
         Owner   : Array[1..2] of S30;
         address : Array[1..2] of String[100];
         name    : Array[1..2] of S60;
       end;
Dog0 = Record
         RND : S60;
         KCR : String[15];
         Marking : S30;
         Breeder : S30;
         Owner   : S30;
         Breed   : S30;
         DB      : S30;
         BA      : String[100];
         OA      : String[100];
         PN      : S30;
         Sex     : S30;
       end;
Dog = record
        Dog         : Dog0;
        SireDam     : SD;
        GParents    : GP;
        GGParents   : GGP;
        GGGParents  : GGGP;
        GGGGParents : GGGGP;
        F           : FDun;
       end;
Procedure open(f : string);                       ForWard;
Procedure Rite(f: S12);                           ForWard;

var
  dogs  : Dog;
  f     : S12;
  PFile : Array[1..8100] of Char;  { 8100 }
  PrinterFile : text;

function Keycode:key;
  var ans:key;
begin
  ans:=readkey;
  if ans[1] = #0 then ans := ans + readkey;
  keycode := ans;
end;

Function DosE(n :byte) : S60;
begin
  DosE := '';
   if n = 2 then DosE := 'File not found'         else
   if n = 3 then DosE := 'Path not found'         else
   if n = 5 then DosE := 'Access denied'          else
   if n = 6 then DosE := 'Invalid handle'         else
   if n = 8 then DosE := 'Not enough memory'      else
   if n = 10 then DosE := 'Invalid environment'   else
   if n = 11 then DosE := 'Invalid format'        else
   if n = 18 then DosE := 'No more files';
end;

function Test(f : string) :Boolean;
    var
    DirInfo: SearchRec;
begin
  Test := True;
  FindFirst(f , Archive, DirInfo);
  if Doserror <> 0 then Test := False;
end;

Function SUpCase(s : String) : String;
  var
    i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := UpCase(s[i]);
  SUpCase := s;
end;

Function CFileName(name,s2 :String): S12;
begin
  name := Copy(name, 1, 8);
  name := ConCat(name, '.',s2);
  CFileName := SUpCase(name);
end;

Procedure InDog;
var
  dog1    : File of dog0;
  DirInfo : SearchRec;
  inut, f : S12;
  k       : Key;
begin
  ClrScr;
   if Dogs.f[0] then
    begin
      WriteLn('Overwrite Field y /n');
      k := KeyCode;
       if k <> 'y' then Exit;
    end;
  FindFirst('\DG2\*.DG2', Archive, DirInfo);
  while DosError = 0 do
    begin
      WriteLn(' ',DirInfo.Name);
      FindNext(DirInfo);
    end;
    WriteLn(DosE(DosError));
    Repeat;
      WriteLn(#10' Type in the name of the file you want with out .DG2 ');
      ReadLn(inut);
       if inut = Esc then Exit;
      f := CFileName(inut, 'dg2');
      if (Test('\DG2\'+f) = false) then WriteLn('file not found ',f);
    Until(Test('\DG2\'+f));
  Assign(dog1, '\DG2\'+f);
  Reset(dog1);
  Read(dog1,dogs.dog);
  close(dog1);
  dogs.F[0] := True
end;

Procedure CInDog;
var
  k       : Key;
  Dog     : Dog0;
  Dog1    : File of Dog0;
  DirInfo : SearchRec;
  F       : S12;
Begin
  ClrScr;
  FindFirst('StartD\DG2\*.DG2', Archive, DirInfo);
   while DosError = 0 do
    begin
      WriteLn(' ',DirInfo.Name);
      FindNext(DirInfo);
    end;
   WriteLn(DosE(DosError));
   WriteLn(' Type in the name of the file you want with out .DG2 ');
   ReadLn(f);
   f := CFileName(f,'DG2');
   if Test('StartD\DG2\'+f) = True then
    begin
      Write(#10#13'FILE ALREADY EXIST OVERWRITE y /n ');
      k := keyCode;
       if k <> 'y' then EXIT;
    end;
   if Test('StartD\DG2\'+f) = False then open('\DG2\'+f);
   if Test('StartD\DG2\'+f) = False then EXIT;
  ClrScr;
  WriteLn('type in the registered name of the dog ');
  ReadLn(Dog.RND);
  WriteLn('type in the K.C.Registration No. of the dog ');
  ReadLn(Dog.KCR);
  WriteLn('type in the marking'#39's of the dog ');
  ReadLn(Dog.Marking);
  WriteLn('type in the breeder of the dog ');
  ReadLn(Dog.Breeder);
  WriteLn('type in the owner of the dog ');
  ReadLn(Dog.Owner);
  WriteLn('type in the breed of the dog ');
  ReadLn(Dog.Breed);
  WriteLn('type in the date of birth of the dog ');
  ReadLn(Dog.DB);
  WriteLn('type in the breeder'#39's address of the dog ');
  ReadLn(Dog.BA);
  WriteLn('type in the owner'#39's address  of the dog ');
  ReadLn(Dog.OA);
  WriteLn('type in the pet name of the dog ');
  ReadLn(Dog.PN);
  WriteLn('type in the sex of the dog ');
  ReadLn(Dog.Sex);
  Assign(Dog1,'\DG2\'+f);
  Rewrite(Dog1);
  Write(Dog1,dog);
  Close(Dog1);
end;

Function ELine(l : String) : String;
var
  k : key;
  la : String;
  pos : Byte;
  inser : Boolean;
begin
  la := l;
  ClrScr;
  inser := True;
  GotoXY(50,1);
  Write(inser,' ');
  GotoXY(2,2);
  Write(l);
  GotoXY(2,2);
  pos := 1;
  k := '';
  repeat

      if (k = ^s) or (k = left)  then pos := pos - 1   else
      if (k = ^d) or (k = right) then pos := pos + 1   else
      if k = home then pos := 1                        else
      if k = end1 then pos := Length(l) + 1            else
      if k = ins  then
       begin
          if (inser = True) then inser := False        else
          inser := True;
       end                                             else
      if (k = ^g) or (k = Del) then Delete(l,pos,1)    else
      if k = bs then
       begin
         pos := pos - 1;
         Delete(l,pos, 1);
       end                                             else
      if length(k) = 1 then
       begin
          if inser = False then
           begin
             l[pos] := k[1];
             pos := pos + 1;
           end                                             else
          if inser = True then
           begin
             Insert(k[1], l, pos);
             pos := pos + 1;
           end;
       end;
      if pos > (length(l) + 1) then pos := Length(l) + 1;
      if pos < 1 then pos := 1;
      GotoXY(50,1);
      Write(inser,' ');
      GotoXY(2 , 2);
      Write(l,'  ');
      GotoXY(1 + pos, 2);
      k := KeyCode;
    Until((k = Esc) or (k = #13));
  ELine := la;
  if k = #13 then ELine := l;
end;

Procedure red(f:S12);
var
  w : file of dog;
  x : Byte;
begin
   if (Test(f)) = False then
    begin
      Open(f);
       if Test(f) = False then exit;
       for x := 0 to 5 do Dogs.f[x] := false;
      Rite(f);
    end;
  Assign(w, f);
  Reset(w);
  Read(w,Dogs);
  Close(w);
end;

Function FindFN(f : S12; y : Boolean) : S12;
var
  DirInfo: SearchRec;
  a      : Byte;
  fn     : Char;
begin
  if y = false then ClrScr;
  WriteLn('PRESS Esc TO EXIT');
  WriteLn;
  FindFirst('*.dog', Archive, DirInfo);
  while (DosError = 0) and (KeyPressed = false) do
    begin
      WriteLn(DirInfo.Name, ' ', #175);
      FindNext(DirInfo);
    end;
   if y = false then Write(#10#13'press Esc to EXIT or any key to chose a file');
   if y = false then fn := ReadKey;
   if (fn <> esc) or (y = true) then
    begin
      Write(#10#13'type in name of file you want ');
      ReadLn(f);
      f := CFileName(f,'dog');
      red(f);
    end;
  FindFN := f;
end;

Procedure open(f : string);
    var
      f2     : file of Dog;
      cmd1   : string;
begin
  ClrScr;
   if Test(f) = False then WriteLn(f ,' file not found crate new y /n') else
   WriteLn('over write ', f,' y /n');
  cmd1 := ReadKey;
  if cmd1 = 'y' then
    begin
      Assign(f2, f);
      Rewrite(f2);
      Close(f2);
    end else
    begin
      Write('can not continue with out ',f);
      Delay(10000);
    end;
end;

Procedure Rite(f: S12);
var
  w : file of Dog;
  begin
     if (Test(f)) = False then
      begin
        Open(f);
      end;
    Assign(w, f);
    Reset(w);
    Write(w, dogs);
    Close(w);
  end;

Procedure edit(f : S12);
var
  inot : Byte;
  fn : file of dog;
  begin
    ClrScr;
    write('whitch field do you want (0 to 62) ');
    ReadLn(inot);
     if inot = 0 then
      begin
        write(#10#13'whitch field do you want in field 0 (1 to 11) ');
        writeLn(#10#13' 1  = Registered Name of Dog');
        writeLn(' 2  = K.C. Registration No');
        writeLn(' 3  = Marking');
        writeLn(' 4  = Breeder');
        writeLn(' 5  = Owner');
        writeLn(' 6  = Breed');
        writeLn(' 7  = Date of Birth');
        writeLn(' 8  = Breeder'#39's Address');
        writeLn(' 9  = Owner'#39's Address');
        writeLn(' 10  = (Pet Name)');
        writeLn(' 11  = Sex');
        ReadLn(inot);
        Write(#10#13'use to be ');
         if inot = 1 then dogs.dog.RND     := ELine(dogs.dog.RND);
         if inot = 2 then dogs.dog.KCR     := ELine(dogs.dog.KCR);
         if inot = 3 then dogs.dog.Marking := ELine(dogs.dog.Marking);
         if inot = 4 then dogs.dog.Breeder := ELine(dogs.dog.Breeder);
         if inot = 5 then dogs.dog.Owner   := ELine(dogs.dog.Owner);
         if inot = 6 then dogs.dog.Breed   := ELine(dogs.dog.Breed);
         if inot = 7 then dogs.dog.DB      := ELine(dogs.dog.DB);
         if inot = 8 then dogs.dog.BA      := ELine(dogs.dog.BA);
         if inot = 9 then dogs.dog.OA      := ELine(dogs.dog.OA);
         if inot = 10 then dogs.dog.PN     := ELine(dogs.dog.PN);
         if inot = 11 then dogs.dog.SEX    := ELine(dogs.dog.SEX);
         rite(f);
         exit;
      end else
     if inot = 1 then
      begin
        write(#10#13'whitch field do you want in field 1 (1 to 4) ');
        ReadLn(inot);
        Write(#10#13'use to be ');
         if inot = 1 then dogs.SireDam.Name[1] := ELine(dogs.SireDam.Name[1]);
         if inot = 2 then dogs.SireDam.KCR[1] := ELine(dogs.SireDam.KCR[1]);
         if inot = 3 then dogs.SireDam.Owner[1] := ELine(dogs.SireDam.Owner[1]);
         if inot = 4 then dogs.SireDam.Address[1] := ELine(dogs.SireDam.Address[1]);
         Rite(f);
         exit;
      end else
     if inot = 2 then
      begin
        write(#10#13'whitch field do you want in field 2 (1 to 4) ');
        ReadLn(inot);
        Write(#10#13'use to be ');
         if inot = 1 then dogs.SireDam.Name[2] := ELine(dogs.SireDam.Name[2]);
         if inot = 2 then dogs.SireDam.KCR[2] := ELine(dogs.SireDam.KCR[2]);
         if inot = 3 then dogs.SireDam.Owner[2] := ELine(dogs.SireDam.Owner[2]);
         if inot = 4 then dogs.SireDam.Address[2] := ELine(dogs.SireDam.Address[2]);
         Rite(f);
         exit;
      end else
     if (inot >= 3) and (inot <= 6) then
      dogs.GParents[inot] := ELine(dogs.GParents[inot]);
     if (inot >= 7) and (inot <= 14) then
      dogs.GGParents[inot] := ELine(dogs.GGParents[inot]);
     if (inot >= 15) and (inot <= 30) then
      dogs.GGGParents[inot] := ELine(dogs.GGGParents[inot]);
     if (inot >= 31) and (inot <= 62) then
      dogs.GGGGParents[inot] := ELine(dogs.GGGGParents[inot]);
    Assign(fn,f);
    Reset(fn);
    Write(fn,dogs);
    Close(fn);
  end;


Function PadTo(s : S175; pad : Byte) : S175;
var
  len,x : Byte;
begin
  len := Length(s);
   if len > pad then
     begin
       Delete(s,pad ,len - pad);
       Write(#13'STRING TO LONG TRUNCATING TO ', s,#10);
       Delay(1000);
     end
   else
     for x := len to pad - 1 do
       s := Concat(s,' ');
  PadTo := s;
end;

Function Pack(s,si : String;pad, lap : byte;yn : Boolean) : String;
var
  len, x, at1, at2,at3, sthart, adlen : byte;
  tes,done, t237   : Boolean;
  waer       : array[1..100] of Byte;
  ws         : Array[1..20] of byte;
  strin      : Array[1..20] of String[80];
begin
  done:=false;
  t237 := False;
  adlen := 0;
  s := Concat(si, s);
  len := Length(s);
  tes := True;
  at1 := 0;
  for x := 1 to len do if s[x] = #237 then
    begin
      at1 := at1 + 1;
      waer[at1] := x;
      t237 := true;
    end;
   if at1 <> 0 then
   if s[len] <> #237 then begin waer[at1+1] := len + 1;adlen := 1 end;
   if t237 = true then
    begin
      for x := 1 to at3 do
       begin
          if x = 1 then strin[x] := copy(s,1,waer[1]- 1) else
         strin[x] := copy(s,waer[x-1]+1,waer[x]-waer[x-1]-1);
       end;
      s := strin[lap];
       if lap > x then s := '';
       if (lap > 1) and done then s:='';
      s := PadTo(s,pad);
      Pack := s;
      Exit;
    end;
   if Length(s) <= pad then done:=true else
   begin
      if at1 = 0 then
       begin
         at1 := 0;
          for x := 1 to len do if s[x] = ' ' then
           begin
             at1 := at1 + 1;
             waer[at1] := x;
           end;
         if s[len] <> ' ' then  begin waer[at1+1] := len + 1;adlen := 1 end;
       end;
     sthart := 0;
     at2 := 0;
     tes := True;
     at3 := 1;
       Repeat
         at2 := at2 + 1;
          if at1 = 0 then
           begin
             WriteLn('word to long');
             Delay(2000);
             Pack := Padto(s,pad);
             Exit;
           end;
          if at2 > at1+1 then ws[at3] := len + adlen else
	  if waer[at2] - sthart  > pad +1 {not been tested fully} then
	   begin
	      if at3 > 20 then
               WriteLn(' to meny words in string ');
              if at2 - 1 < 1 then
               WriteLn('Error in Procedure');
	     ws[at3] := waer[at2-1];
             sthart := waer[at2-1];
             at3 := at3 + 1;
           end;
          if at2 > at1 + 1 then tes := False;
       Until(tes = False);
     for x := 1 to at3 do
       begin
          if x = 1 then strin[x] := copy(s,1,ws[1]- 1) else
         strin[x] := copy(s,ws[x-1]+1,ws[x]-ws[x-1]-1);
       end;
     if (x > lap) and (yn = False) then
      begin
	Writeln(#10#13'STRING NOT BEING UESD FULLY');
        Delay(3000);
      end;
   s := strin[lap];
   end;
   if lap > x then s := '';
   if (lap > 1) and done then s:='';
  s := PadTo(s,pad);
  Pack := s;
end;

Procedure CPrint;
const
   topline = ''+
             ''+
             '';
   midline = ''+
             ''+
             '';
   botline = ''+
             ''+
             '';
var
  f2 : file of char;
  temp : S175;
  x , xy, AtChar : word;
  len    : Byte;
  a  : array[1..46] of String[175];
  sd : Array[1..16] of String[30];
  gp : Array[1..16] of String[15];
  ggp : Array[1..16] of String[20];
  gggp : Array[1..16] of String[30];
  ggggp : Array[1..16] of String[61];

procedure arr(ud : Byte); { IN CPRINT }
const
  y = true; n = False;
var
  temp :String;
  x,la : Byte;
begin
  if ud = 1 then
  begin

  sd[1]  := padto('  1. SIRE',30);
  sd[2]  := padto('     Name',30);
  sd[3]  := Pack(dogs.SireDam.Name[1],'',30,1,y);
  sd[4]  := Pack(Dogs.SireDam.Name[1],'',30,2,n);
  sd[5]  := padto('     K.C. Registration',30);
  sd[6]  := PadTo(Dogs.SireDam.KCR[1],30);
  sd[7]  := padto('     Owner',30);
  sd[8]  := Pack(Dogs.SireDam.Owner[1],'',30,1,y);
  sd[9]  := Pack(Dogs.SireDam.Owner[1],'',30,2,n);
  sd[10] := PadTo('     Address',30);
  la := 0;
  for x := 11 to 15 do
    begin
      la := la + 1;
      sd[x] := Pack(Dogs.SireDam.Address[1],'',30,la,y);
    end;
  sd[16] := Pack(Dogs.SireDam.Address[1],'',30,6,n);
  gp[1]  := PadTo('  3. SIRE',15);
  la := 0;
  for x := 2 to 7 do
    begin
      la := la + 1;
      gp[x]  := Pack(Dogs.GParents[3],'',15,la,Y);
    end;
  gp[8]  := Pack(Dogs.GParents[3],'',15,7,N);
  gp[9] := PadTo('  4. DAM',15);
  la := 0;
   for x := 10 to 15 do
    begin
      la := la + 1;
      gp[x]  := Pack(Dogs.GParents[4],'',15,la,Y);
    end;
  GP[16] := Pack(Dogs.GParents[4],'',15,7,N);
  { END OF FIELD 2 BEGINING OF FIELD 3}
  ggp[1] := PadTo('  7. SIRE',20);
  ggp[2] := Pack(Dogs.GGParents[7],'',20,1,y);
  ggp[3] := Pack(Dogs.GGParents[7],'',20,2,y);
  ggp[4] := Pack(Dogs.GGParents[7],'',20,3,N);
  ggp[5] := PadTo('  8. DAM',20);
  ggp[6] := Pack(Dogs.GGParents[8],'',20,1,y);
  ggp[7] := Pack(Dogs.GGParents[8],'',20,2,y);
  ggp[8] := Pack(Dogs.GGParents[8],'',20,3,N);
  ggp[9] := PadTo('  9. SIRE',20);
  ggp[10] := Pack(Dogs.GGParents[9],'',20,1,y);
  ggp[11] := Pack(Dogs.GGParents[9],'',20,2,y);
  ggp[12] := Pack(Dogs.GGParents[9],'',20,3,N);
  ggp[13] := PadTo('  10. DAM',20);
  ggp[14] := Pack(Dogs.GGParents[10],'',20,1,y);
  ggp[15] := Pack(Dogs.GGParents[10],'',20,2,y);
  ggp[16] := Pack(Dogs.GGParents[10],'',20,3,N);
  { END OF FIELD 3 BEGINING OF FIELD 4}
  gggp[1]  := Pack(Dogs.GGGParents[15], ' 15. SIRE ', 30,1,y);
  gggp[2]  := Pack(Dogs.GGGParents[15], ' 15. SIRE ', 30,2,n);
  gggp[3]  := Pack(Dogs.GGGParents[16], ' 16. DAM ' , 30,1,y);
  gggp[4]  := Pack(Dogs.GGGParents[16], ' 16. DAM ' , 30,2,n);
  gggp[5]  := Pack(Dogs.GGGParents[17], ' 17. SIRE ', 30,1,y);
  gggp[6]  := Pack(Dogs.GGGParents[17], ' 17. SIRE ', 30,2,n);
  gggp[7]  := Pack(Dogs.GGGParents[18], ' 18. DAM ' , 30,1,y);
  gggp[8]  := Pack(Dogs.GGGParents[18], ' 18. DAM ' , 30,2,n);
  gggp[9]  := Pack(Dogs.GGGParents[19], ' 19. SIRE ', 30,1,y);
  gggp[10] := Pack(Dogs.GGGParents[19], ' 19. SIRE ', 30,2,n);
  gggp[11] := Pack(Dogs.GGGParents[20], ' 20. DAM ' , 30,1,y);
  gggp[12] := Pack(Dogs.GGGParents[20], ' 20. DAM ' , 30,2,n);
  gggp[13] := Pack(Dogs.GGGParents[21], ' 21. SIRE ', 30,1,y);
  gggp[14] := Pack(Dogs.GGGParents[21], ' 21. SIRE ', 30,2,n);
  gggp[15] := Pack(Dogs.GGGParents[22], ' 22. DAM ' , 30,1,y);
  gggp[16] := Pack(Dogs.GGGParents[22], ' 22. DAM ', 30,2,n);
  { END OF FIELD 4 BEGINING OF FIELD 5}
  ggggp[1]  := Pack(Dogs.GGGGParents[31],' 31. SIRE ', 61,1,n);
  ggggp[2]  := Pack(Dogs.GGGGParents[32],' 32. DAM ' , 61,1,N);
  ggggp[3]  := Pack(Dogs.GGGGParents[33],' 33. SIRE ', 61,1,N);
  ggggp[4]  := Pack(Dogs.GGGGParents[34],' 34. DAM ' , 61,1,N);
  ggggp[5]  := Pack(Dogs.GGGGParents[35],' 35. SIRE ', 61,1,N);
  ggggp[6]  := Pack(Dogs.GGGGParents[36],' 36. DAM ' , 61,1,N);
  ggggp[7]  := Pack(Dogs.GGGGParents[37],' 37. SIRE ', 61,1,N);
  ggggp[8]  := Pack(Dogs.GGGGParents[38],' 38. DAM ' , 61,1,N);
  ggggp[9]  := Pack(Dogs.GGGGParents[39],' 39. SIRE ', 61,1,N);
  ggggp[10] := Pack(Dogs.GGGGParents[40],' 40. DAM ' , 61,1,N);
  ggggp[11] := Pack(Dogs.GGGGParents[41],' 41. SIRE ', 61,1,N);
  ggggp[12] := Pack(Dogs.GGGGParents[42],' 42. DAM ' , 61,1,N);
  ggggp[13] := Pack(Dogs.GGGGParents[43],' 43. SIRE ', 61,1,N);
  ggggp[14] := Pack(Dogs.GGGGParents[44],' 44. DAM ' , 61,1,N);
  ggggp[15] := Pack(Dogs.GGGGParents[45],' 45. SIRE ', 61,1,N);
  ggggp[16] := Pack(Dogs.GGGGParents[46],' 46. DAM ' , 61,1,N);
  end else
  { dam     }
  if ud = 2 then
  begin
  sd[1]  := PadTo('  2. DAM ',30);
  sd[2]  := PadTo('     Name',30);
  sd[3]  := Pack(dogs.SireDam.Name[2],'',30,1,y);
  sd[4]  := Pack(Dogs.SireDam.Name[2],'', 30,2,n);
  sd[5]  := PadTo('     K.C. Registration',30);
  sd[6]  := PadTo(Dogs.SireDam.KCR[2],30);
  sd[7]  := PadTo('     Owner',30);
  sd[8]  := Pack(Dogs.SireDam.Owner[2],'',30,1,y);
  sd[9]  := Pack(Dogs.SireDam.Owner[2],'',30,2,n);
  sd[10] := PadTo('     Address',30);
  la := 0;
  for x := 11 to 15 do
    begin
      la := la + 1;
      sd[x] := Pack(Dogs.SireDam.Address[2],'',30,la,y);
    end;
  sd[16] := Pack(Dogs.SireDam.Address[2],'',30,6,n);
  gp[1]  := PadTo('  5. SIRE',15);
  la := 0;
   for x := 2 to 7 do
    begin
      la := la + 1;
      gp[x]  := Pack(Dogs.GParents[5],'',15,la,Y);
    end;
  gp[8]  := Pack(Dogs.GParents[5],'',15,7,N);
  gp[9] := PadTo('  6. DAM',15);
  la := 0;
   for x := 10 to 15 do
    begin
      la := la + 1;
      gp[x]  := Pack(Dogs.GParents[6],'',15,la,Y);
    end;
  GP[16] := Pack(Dogs.GParents[6],'',15,7,N);
  { END OF FIELD 2 BEGINING OF FIELD 3}
  ggp[1] := PadTo('  11. SIRE',20);
  ggp[2] := Pack(Dogs.GGParents[11],'',20,1,y);
  ggp[3] := Pack(Dogs.GGParents[11],'',20,2,y);
  ggp[4] := Pack(Dogs.GGParents[11],'',20,3,N);
  ggp[5] := PadTo('  12. DAM',20);
  ggp[6] := Pack(Dogs.GGParents[12],'',20,1,y);
  ggp[7] := Pack(Dogs.GGParents[12],'',20,2,y);
  ggp[8] := Pack(Dogs.GGParents[12],'',20,3,N);
  ggp[9] := PadTo('  13. SIRE',20);
  ggp[10] := Pack(Dogs.GGParents[13],'',20,1,y);
  ggp[11] := Pack(Dogs.GGParents[13],'',20,2,y);
  ggp[12] := Pack(Dogs.GGParents[13],'',20,3,N);
  ggp[13] := PadTo('  14. DAM',20);
  ggp[14] := Pack(Dogs.GGParents[14],'',20,1,y);
  ggp[15] := Pack(Dogs.GGParents[14],'',20,2,y);
  ggp[16] := Pack(Dogs.GGParents[14],'',20,3,N);
  { END OF FIELD 3 BEGINING OF FIELD 4}
  gggp[1]  := Pack(Dogs.GGGParents[23], ' 23. SIRE ', 30,1,y);
  gggp[2]  := Pack(Dogs.GGGParents[23], ' 23. SIRE ', 30,2,n);
  gggp[3]  := Pack(Dogs.GGGParents[24], ' 24. DAM ' , 30,1,y);
  gggp[4]  := Pack(Dogs.GGGParents[24], ' 24. DAM ' , 30,2,n);
  gggp[5]  := Pack(Dogs.GGGParents[25], ' 25. SIRE ', 30,1,y);
  gggp[6]  := Pack(Dogs.GGGParents[25], ' 25. SIRE ', 30,2,n);
  gggp[7]  := Pack(Dogs.GGGParents[26], ' 26. DAM ' , 30,1,y);
  gggp[8]  := Pack(Dogs.GGGParents[26], ' 26. DAM ' , 30,2,n);
  gggp[9]  := Pack(Dogs.GGGParents[27], ' 27. SIRE ', 30,1,y);
  gggp[10] := Pack(Dogs.GGGParents[27], ' 27. SIRE ', 30,2,n);
  gggp[11] := Pack(Dogs.GGGParents[28], ' 28. DAM ' , 30,1,y);
  gggp[12] := Pack(Dogs.GGGParents[28], ' 28. DAM ' , 30,2,n);
  gggp[13] := Pack(Dogs.GGGParents[29], ' 29. SIRE ', 30,1,y);
  gggp[14] := Pack(Dogs.GGGParents[29], ' 29. SIRE ', 30,2,n);
  gggp[15] := Pack(Dogs.GGGParents[30], ' 30. DAM ' , 30,1,y);
  gggp[16] := Pack(Dogs.GGGParents[30], ' 30. DAM ' , 30,2,n);
  { END OF FIELD 4 BEGINING OF FIELD 5}
  ggggp[1]  := Pack(Dogs.GGGGParents[47],' 47. SIRE ', 61,1,n);
  ggggp[2]  := Pack(Dogs.GGGGParents[48],' 48. DAM ' , 61,1,N);
  ggggp[3]  := Pack(Dogs.GGGGParents[49],' 49. SIRE ', 61,1,N);
  ggggp[4]  := Pack(Dogs.GGGGParents[50],' 50. DAM ' , 61,1,N);
  ggggp[5]  := Pack(Dogs.GGGGParents[51],' 51. SIRE ', 61,1,N);
  ggggp[6]  := Pack(Dogs.GGGGParents[52],' 52. DAM ' , 61,1,N);
  ggggp[7]  := Pack(Dogs.GGGGParents[53],' 53. SIRE ', 61,1,N);
  ggggp[8]  := Pack(Dogs.GGGGParents[54],' 54. DAM ' , 61,1,N);
  ggggp[9]  := Pack(Dogs.GGGGParents[55],' 55. SIRE ', 61,1,N);
  ggggp[10] := Pack(Dogs.GGGGParents[56],' 56. DAM ' , 61,1,N);
  ggggp[11] := Pack(Dogs.GGGGParents[57],' 57. SIRE ', 61,1,N);
  ggggp[12] := Pack(Dogs.GGGGParents[58],' 58. DAM ' , 61,1,N);
  ggggp[13] := Pack(Dogs.GGGGParents[59],' 59. SIRE ', 61,1,N);
  ggggp[14] := Pack(Dogs.GGGGParents[60],' 60. DAM ' , 61,1,N);
  ggggp[15] := Pack(Dogs.GGGGParents[61],' 61. SIRE ', 61,1,N);
  ggggp[16] := Pack(Dogs.GGGGParents[62],' 62. DAM ' , 61,1,N);
  end;
end;                        { procedure arr IN CPRINT }

begin                       { BEGIN procedure CPRINT }
  ClrScr;
  Write(' PLEASE WAIT (CPRINT)');
  for x := 1 to 46 do
    a[x] := '';
   for x := 0 to 5 do
     if  not Dogs.f[x] then
       begin
         Write(#10#13'CAN'#39'T FIELD ', x,' = FALSE');
         Delay(2000);
         exit;
       end;
  temp := Concat(' REGISTERED NAME OF DOG ',Dogs.Dog.RND);
  temp := PadTo(temp,80);
  a[1] := Concat(temp,' (PET NAME) ', Dogs.dog.PN, lf);
  temp := Concat(' K.C. REGISTRATION No. ',Dogs.Dog.KCR);
  temp := PadTo(temp,40);
  temp := Concat(temp, ' BREED ', Dogs.dog.Breed);
  temp := PadTo(temp,80);
  a[2] := Concat(temp, ' SEX ', Dogs.dog.Sex, lf);
  temp := Concat(' MARKING ', Dogs.Dog.Marking);
  temp := PadTo(temp,40);
  a[3] := Concat(temp,' DATE OF BIRTH ', Dogs.dog.DB, lf);
  temp := Concat(' BREEDER ', Dogs.Dog.Breeder);
  temp := PadTo(temp,40);
  a[4] := Concat(temp,' BREEDER'#39'S ADDRESS ', Dogs.dog.BA, lf);
  temp := Concat(' OWNER ', Dogs.Dog.Owner);
  temp := PadTo(temp,40);
  a[5] := Concat(temp,' OWNER'#39'S ADDRESS ', Dogs.dog.OA, lf);
  { END OF DOG }
  a[6]  := Concat(TopLine,lf);
  Arr(1);
  a[7] := Concat(Padto(ds+' Sire & dam',30),
          PadTo(ds+'Grand Parents',16),
          PadTo(ds+'Great Grand Parents',21),
          PadTo(ds+'Great Great Grand Parents',31),
          PadTo(ds+'Great Great Great Grand Parents',61),lf);
  a[8]  := Concat(MidLine,lf);
  a[9]  := Concat(sd[1] ,#186,    gp[1] ,#186,    ggp[1] ,#186,    gggp[1] ,#186,un1,ggggp[1] ,un0,lf);
  a[10] := Concat(sd[2] ,#186,    gp[2] ,#186,    ggp[2] ,#186,Un1,gggp[2] ,#186,    ggggp[2] ,un0,lf);
  a[11] := Concat(sd[3] ,#186,    gp[3] ,#186,    ggp[3] ,#186,    gggp[3] ,#186,un1,ggggp[3] ,un0,lf);
  a[12] := Concat(sd[4] ,#186,    gp[4] ,#186,un1,ggp[4] ,#186,    gggp[4] ,#186,    ggggp[4] ,un0,lf);
  a[13] := Concat(sd[5] ,#186,    gp[5] ,#186,    ggp[5] ,#186,    gggp[5] ,#186,un1,ggggp[5] ,un0,lf);
  a[14] := Concat(sd[6] ,#186,    gp[6] ,#186,    ggp[6] ,#186,un1,gggp[6] ,#186,    ggggp[6] ,un0,lf);
  a[15] := Concat(sd[7] ,#186,    gp[7] ,#186,    ggp[7] ,#186,    gggp[7] ,#186,un1,ggggp[7] ,un0,lf);
  a[16] := Concat(sd[8] ,#186,un1,gp[8] ,#186,    ggp[8] ,#186,    gggp[8] ,#186,    ggggp[8] ,un0,lf);
  a[17] := Concat(sd[9] ,#186,    gp[9] ,#186,    ggp[9] ,#186,    gggp[9] ,#186,un1,ggggp[9] ,un0,lf);
  a[18] := Concat(sd[10],#186,    gp[10],#186,    ggp[10],#186,un1,gggp[10],#186,    ggggp[10],un0,lf);
  a[19] := Concat(sd[11],#186,    gp[11],#186,    ggp[11],#186,    gggp[11],#186,un1,ggggp[11],un0,lf);
  a[20] := Concat(sd[12],#186,    gp[12],#186,un1,ggp[12],#186,    gggp[12],#186,    ggggp[12],un0,lf);
  a[21] := Concat(sd[13],#186,    gp[13],#186,    ggp[13],#186,    gggp[13],#186,un1,ggggp[13],un0,lf);
  a[22] := Concat(sd[14],#186,    gp[14],#186,    ggp[14],#186,un1,gggp[14],#186,    ggggp[14],un0,lf);
  a[23] := Concat(sd[15],#186,    gp[15],#186,    ggp[15],#186,    gggp[15],#186,un1,ggggp[15],un0,lf);
  a[24] := Concat(un1,sd[16],#186,gp[16],#186,    ggp[16],#186,    gggp[16],#186,    ggggp[16],un0,lf);
  Arr(2);
  a[25] := Concat(sd[1] ,#186,    gp[1] ,#186,    ggp[1] ,#186,    gggp[1] ,#186,un1,ggggp[1] ,un0,lf);
  a[26] := Concat(sd[2] ,#186,    gp[2] ,#186,    ggp[2] ,#186,un1,gggp[2] ,#186,    ggggp[2] ,un0,lf);
  a[27] := Concat(sd[3] ,#186,    gp[3] ,#186,    ggp[3] ,#186,    gggp[3] ,#186,un1,ggggp[3] ,un0,lf);
  a[28] := Concat(sd[4] ,#186,    gp[4] ,#186,un1,ggp[4] ,#186,    gggp[4] ,#186,    ggggp[4] ,un0,lf);
  a[29] := Concat(sd[5] ,#186,    gp[5] ,#186,    ggp[5] ,#186,    gggp[5] ,#186,un1,ggggp[5] ,un0,lf);
  a[30] := Concat(sd[6] ,#186,    gp[6] ,#186,    ggp[6] ,#186,un1,gggp[6] ,#186,    ggggp[6] ,un0,lf);
  a[31] := Concat(sd[7] ,#186,    gp[7] ,#186,    ggp[7] ,#186,    gggp[7] ,#186,un1,ggggp[7] ,un0,lf);
  a[32] := Concat(sd[8] ,#186,un1,gp[8] ,#186,    ggp[8] ,#186,    gggp[8] ,#186,    ggggp[8] ,un0,lf);
  a[33] := Concat(sd[9] ,#186,    gp[9] ,#186,    ggp[9] ,#186,    gggp[9] ,#186,un1,ggggp[9] ,un0,lf);
  a[34] := Concat(sd[10],#186,    gp[10],#186,    ggp[10],#186,un1,gggp[10],#186,    ggggp[10],un0,lf);
  a[35] := Concat(sd[11],#186,    gp[11],#186,    ggp[11],#186,    gggp[11],#186,un1,ggggp[11],un0,lf);
  a[36] := Concat(sd[12],#186,    gp[12],#186,un1,ggp[12],#186,    gggp[12],#186,    ggggp[12],un0,lf);
  a[37] := Concat(sd[13],#186,    gp[13],#186,    ggp[13],#186,    gggp[13],#186,un1,ggggp[13],un0,lf);
  a[38] := Concat(sd[14],#186,    gp[14],#186,    ggp[14],#186,un1,gggp[14],#186,    ggggp[14],un0,lf);
  a[39] := Concat(sd[15],#186,    gp[15],#186,    ggp[15],#186,    gggp[15],#186,un1,ggggp[15],un0,lf);
  a[40] := Concat(sd[16],#186,    gp[16],#186,    ggp[16],#186,    gggp[16],#186,    ggggp[16],    lf);
  a[41] := Concat(BotLine,lf);
  a[42] := lf;
  a[43] := Concat('SIGNED_______________________________________________ DATE______________________________',lf);
  a[44] := Concat('ADDRESS_________________________________________________________________________________',lf);
  a[45] := Concat('________________________________________________________________________________________',lf);
  AtChar := 1;
  for x := 1 to 46 do
    begin
      len := Length(a[x]);
      for xy := 1 to len do
        begin
          Pfile[AtChar] := a[x][xy];
          inc(AtChar);
        end
    end;
  Pfile[AtChar] := '';
  assign(PrinterFile,'dog.prn');
  rewrite(PrinterFile);
  x:=1;
  while Pfile[x] <> '' do
    begin
      write(PrinterFile,Pfile[x]);
      inc(x);
    end;
  close(PrinterFile);
end;

procedure mane(field : Byte);
var
  k : key;
  field2, e, b, x  : Byte;
  iput : String;
begin
   if field = 0  then begin e := 1;  b := 1;  end else
   if field = 1  then begin e := 1;  b := 1;  end else
   if field = 2  then begin e := 6;  b := 3;  end else
   if field = 3  then begin e := 14; b := 7;  end else
   if field = 4  then begin e := 30; b := 15; end else
   if field = 5  then begin e := 62; b := 31; end else
  EXIT;
  ClrScr;
   if Test(f) = False then open(f);
   if Test(f) = False then EXIT;
   if Dogs.F[Field] = true then
    begin
      Write(#10#13'FIELD ALREADY EXIST OVERWRITE y /n ');
      k := KeyCode;
       if k <> 'y' then EXIT;
    end;
  Write(#13'hold doun the Alt key and type 237 for retern ie '#10);
   for x := b to e do
    begin
     Write(#13'type in record ', x, ' field ', field,' ');
      if field > 1 then ReadLn(iput);
      if field = 2 then Dogs.GParents[x] := iput else
      if field = 3 then Dogs.GGParents[x] := iput else
      if field = 4 then Dogs.GGGParents[x] := iput else
      if field = 5 then Dogs.GGGGParents[x] := iput else
      if field = 0 then
       begin
         ClrScr;
         WriteLn('type in the registered name of the dog ');
         ReadLn(iput);
         Dogs.Dog.RND := iput;
         WriteLn('type in the K.C.registration No. of the dog ');
         ReadLn(iput);
         Dogs.Dog.KCR := iput;
         WriteLn('type in the marking'#39's of the dog ');
         ReadLn(iput);
         Dogs.Dog.Marking := iput;
         WriteLn('type in the breeder of the dog ');
         ReadLn(iput);
         Dogs.Dog.Breeder := iput;
         WriteLn('type in the owner of the dog ');
         ReadLn(iput);
         Dogs.Dog.Owner := iput;
         WriteLn('type in the breed of the dog ');
         ReadLn(iput);
         Dogs.Dog.Breed := iput;
         WriteLn('type in the date of birth of the dog ');
         ReadLn(iput);
         Dogs.Dog.DB := iput;
         WriteLn('type in the breeder'#39's address of the dog ');
         ReadLn(iput);
         Dogs.Dog.BA := iput;
         WriteLn('type in the owner'#39's address  of the dog ');
         ReadLn(iput);
         Dogs.Dog.OA := iput;
         WriteLn('type in the pet name of the dog ');
         ReadLn(iput);
         Dogs.Dog.PN := iput;
         WriteLn('type in the sex of the dog ');
         ReadLn(iput);
         Dogs.Dog.Sex := iput;
       end;
      if field = 1 then
       begin
         ClrScr;
         WriteLn('type in the name of the sire ');
         ReadLn(iput);
         Dogs.SireDam.name[1] := iput;
         WriteLn('type in the K.C.Registration  of the sire ');
         ReadLn(iput);
         Dogs.SireDam.KCR[1] := iput;
         WriteLn('type in the name of the owner of the sire ');
         ReadLn(iput);
         Dogs.SireDam.Owner[1] := iput;
         WriteLn('type in the address of the owner of the sire ');
         ReadLn(iput);
         Dogs.SireDam.Address[1] := iput;
         WriteLn('type in the name of the dam ');
         ReadLn(iput);
         Dogs.SireDam.name[2] := iput;
         WriteLn('type in the K.C.Registration  of the dam ');
         ReadLn(iput);
         Dogs.SireDam.KCR[2] := iput;
         WriteLn('type in the name of the owner of the dam ');
         ReadLn(iput);
         Dogs.SireDam.Owner[2] := iput;
         WriteLn('type in the address of the owner of the dam ');
         ReadLn(iput);
         Dogs.SireDam.Address[2] := iput;
       end;
   end;
  Dogs.F[field] := True;
  Rite(f);
end;

procedure Print;
var i:word;
  ch : char;
begin
  ClrScr;
  Write(' PLEASE WAIT (PRINT)');
  Write(Lst,CND12,LPI);
  assign(PrinterFile,'DOG.PRN');
  reset(PrinterFile);
  while not eof(PrinterFile) do
    begin
      read(PrinterFile,ch);
      write(Lst,ch)
    end;
  close(PrinterFile);
end;

procedure merg;
var
  DogsS,dogsD : dog;
  K           : Key;
  f1,f2       : S12;
  FN          : File of dog;
  x           : Byte;
begin
    Repeat;
      ClrScr;
      k := 'y';
      Write('PLEASE TYPE IN THE NAME OF THE DOG YOU WHANT TO CREATE A FILE FOR. ');
      ReadLn(f);
      f := CFileName(f,'DOG');
       if Test(f) = True then
        begin
          Write(#13'FILE ALREADY EXIST OVERWRITE y /n ',f,#10);
          k := KeyCode;
           if k = 'n' then EXIT;
        end;
    Until(k = 'y');
    Repeat;
      ClrScr;
      Write('PLEASE TYPE IN THE NAME OF THE SIRE'#39'S FILE '#10);
      f1 := FindFN(f1,true);
      if Test(f1) = False then Write(#13'FILE NOT FOUND ',f1,#10);
      Delay(2000);
    Until(Test(f1) = True);
    Repeat;
      ClrScr;
      WriteLn('PLEASE TYPE IN THE NAME OF THE DAM'#39'S FILE '#10);
      f2 := FindFN(f2,true);
      if Test(f2) = False then Write(#13'FILE NOT FOUND ',f2,#10);
      Delay(2000);
    Until(Test(f2) = True);
  Assign(fn,f1);
  Reset(fn);
  Read(fn,DogsS);
  Close(fn);
  Assign(fn,f2);
  Reset(fn);
  Read(fn,DogsD);
  Close(fn);
   for x := 0 to 4 do if (dogsS.f[x] = false) then
    begin
      ClrScr;
      WriteLn(#10#13'File not completed ', f1);
      Delay(2000);
      Exit;
    end;
   for x := 0 to 4 do if (DogsD.f[x] = false) then
    begin
      ClrScr;
      WriteLn(#10#13'File not completed ', f2);
      Delay(2000);
      Exit;
    end;
  for x := 1 to 5 do Dogs.f[x] := True;
  Dogs.F[0] := False;
  Dogs.SireDam.Name[1]    := DogsS.dog.RND;
  Dogs.SireDam.KCR[1]     := DogsS.dog.KCR;
  Dogs.SireDam.Owner[1]   := DogsS.dog.Owner;
  Dogs.SireDam.Address[1] := DogsS.dog.OA;
  Dogs.SireDam.Name[2]    := DogsD.dog.RND;
  Dogs.SireDam.KCR[2]     := DogsD.dog.KCR;
  Dogs.SireDam.Owner[2]   := DogsD.dog.Owner;
  Dogs.SireDam.Address[2] := DogsD.dog.OA;
  { END OF SireDam}
  Dogs.GParents[3] := DogsS.SireDam.Name[1];
  Dogs.GParents[4] := DogsS.SireDam.Name[2];
  Dogs.GParents[5] := DogsD.SireDam.Name[1];
  Dogs.GParents[6] := DogsD.SireDam.Name[2];
  { END OF GPARENTS}
  Dogs.GGParents[7]  := DogsS.GParents[3];
  Dogs.GGParents[8]  := DogsS.GParents[4];
  Dogs.GGParents[9]  := DogsS.GParents[5];
  Dogs.GGParents[10] := DogsS.GParents[6];
  Dogs.GGParents[11] := DogsD.GParents[3];
  Dogs.GGParents[12] := DogsD.GParents[4];
  Dogs.GGParents[13] := DogsD.GParents[5];
  Dogs.GGParents[14] := DogsD.GParents[6];
  { END OF GGPARENTS}
  Dogs.GGGParents[15] := DogsS.GGParents[7];
  Dogs.GGGParents[16] := DogsS.GGParents[8];
  Dogs.GGGParents[17] := DogsS.GGParents[9];
  Dogs.GGGParents[18] := DogsS.GGParents[10];
  Dogs.GGGParents[19] := DogsS.GGParents[11];
  Dogs.GGGParents[20] := DogsS.GGParents[12];
  Dogs.GGGParents[21] := DogsS.GGParents[13];
  Dogs.GGGParents[22] := DogsS.GGParents[14];
  Dogs.GGGParents[23] := DogsD.GGParents[7];
  Dogs.GGGParents[24] := DogsD.GGParents[8];
  Dogs.GGGParents[25] := DogsD.GGParents[9];
  Dogs.GGGParents[26] := DogsD.GGParents[10];
  Dogs.GGGParents[27] := DogsD.GGParents[11];
  Dogs.GGGParents[28] := DogsD.GGParents[12];
  Dogs.GGGParents[29] := DogsD.GGParents[13];
  Dogs.GGGParents[30] := DogsD.GGParents[14];
  { END OF GGGPARENTS}
  Dogs.GGGGParents[31] := DogsS.GGGParents[15];
  Dogs.GGGGParents[32] := DogsS.GGGParents[16];
  Dogs.GGGGParents[33] := DogsS.GGGParents[17];
  Dogs.GGGGParents[34] := DogsS.GGGParents[18];
  Dogs.GGGGParents[35] := DogsS.GGGParents[19];
  Dogs.GGGGParents[36] := DogsS.GGGParents[20];
  Dogs.GGGGParents[37] := DogsS.GGGParents[21];
  Dogs.GGGGParents[38] := DogsS.GGGParents[22];
  Dogs.GGGGParents[39] := DogsS.GGGParents[23];
  Dogs.GGGGParents[40] := DogsS.GGGParents[24];
  Dogs.GGGGParents[41] := DogsS.GGGParents[25];
  Dogs.GGGGParents[42] := DogsS.GGGParents[26];
  Dogs.GGGGParents[43] := DogsS.GGGParents[27];
  Dogs.GGGGParents[44] := DogsS.GGGParents[28];
  Dogs.GGGGParents[45] := DogsS.GGGParents[29];
  Dogs.GGGGParents[46] := DogsS.GGGParents[30];
  Dogs.GGGGParents[47] := DogsD.GGGParents[15];
  Dogs.GGGGParents[48] := DogsD.GGGParents[16];
  Dogs.GGGGParents[49] := DogsD.GGGParents[17];
  Dogs.GGGGParents[50] := DogsD.GGGParents[18];
  Dogs.GGGGParents[51] := DogsD.GGGParents[19];
  Dogs.GGGGParents[52] := DogsD.GGGParents[20];
  Dogs.GGGGParents[53] := DogsD.GGGParents[21];
  Dogs.GGGGParents[54] := DogsD.GGGParents[22];
  Dogs.GGGGParents[55] := DogsD.GGGParents[23];
  Dogs.GGGGParents[56] := DogsD.GGGParents[24];
  Dogs.GGGGParents[57] := DogsD.GGGParents[25];
  Dogs.GGGGParents[58] := DogsD.GGGParents[26];
  Dogs.GGGGParents[59] := DogsD.GGGParents[27];
  Dogs.GGGGParents[60] := DogsD.GGGParents[28];
  Dogs.GGGGParents[61] := DogsD.GGGParents[29];
  Dogs.GGGGParents[62] := DogsD.GGGParents[30];
  {END OF GGGGPARENTS}
  Assign(fn,f);
  Rewrite(fn);
  Write(fn,Dogs);
  Close(fn);
end;

Procedure look;
var
  ProgramName, CmdLine: string;
  begin
    ClrScr;
    ProgramName := 'MORE.COM';
    CmdLine := 'DOG.PRN';
    SwapVectors;
    Exec(ProgramName, CmdLine);
    ClrScr;
    SwapVectors;
    WriteLn('...back from Exec');
    if DosError <> 0 then{ Error? }
     begin
       WriteLn('Dos error #', DosError);
       Delay(2000);
     end;
end;

Procedure Boo;
var
  pas : S12;
  k   : key;
  x   : Byte;
begin
  ClrScr;
   for x := 0 to 5 do WriteLn( x,' Field ',Dogs.F[x]);
  k := KeyCode;
   if k <> 't' then Exit;
  Writeln('type in pascode ');
  ReadLn(pas);
   if pas <> 'gtyhj' then EXIT;
  WriteLn('Whitch field');
  k := KeyCode;
   if k = '0' then Dogs.F[0] := true;
   if k = '1' then Dogs.F[1] := true;
   if k = '2' then Dogs.F[2] := true;
   if k = '3' then Dogs.F[3] := true;
   if k = '4' then Dogs.F[4] := true;
   if k = '5' then Dogs.F[5] := true;
   if k = 'a' then for x := 0 to 5 do Dogs.F[x] := true;
   Rite(f);
end;

var
  s    : String;
  k    : Key;
  field : Byte;
  st    : file of Star;
  stat  : Star;
BEGIN
  Field := 2;
  Assign(st,'SHART.DOG');
  Reset(st);
  Read(st,stat);
  Close(st);
  f := stat.f;
  Field := stat.Field;
  red(f);
    Repeat
      ClrScr;
      Write('TYPE IN THE LETTER OF THE OPTION YOU WANT {CASE SENSTIVE}'#10);
      Write(#13'  0   = Dog'#39's details'#10);
      Write(#13'  1   = Sire & Dam'#10);
      Write(#13'  2   = Grand Parents{field 1}'#10);
      Write(#13'  3   = Great Grand Parents'#10);
      Write(#13'  4   = Great Great Grand Parents'#10);
      Write(#13'  5   = Great Great Great Grand Parents'#10);
      Write(#13'  Esc = EXIT'#10);
      Write(#13'  t   = type in Data in field ', field,#10);
      Write(#13'  c   = create printer file for ', f, #10);
      Write(#13'  f   = find file'#10);
      Write(#13'  p   = print file DOG.PRN'#10);
      Write(#13'  m   = create a file for a dog from it'#39's sire & dam'#10);
      Write(#13'  e   = edit file ',f,#10);
      Write(#13'  l   = look at printer file'#10);
      Write(#13'  b   = Boolean'#10);
      Write(#13'  C   = create a file for field 0'#10);
      Write(#13'  i   = fill field 0 with field field'#10);
      Write(#13'  Field ',Field);
      k := KeyCode;

       if k = '0' then field := 0             else
       if k = '1' then field := 1             else
       if k = '2' then field := 2             else
       if k = '3' then field := 3             else
       if k = '4' then field := 4             else
       if k = '5' then field := 5             else
       if k = 'C' then CInDog                 else
       if k = 'i' then InDog                  else
       if k = 't' then mane(field)            else
       if k = 'f' then f := FindFN(f,false)   else
       if k = 'p' then Print                  else
       if k = 'm' then merg                   else
       if k = 'e' then edit(f)                else
       if k = 'c' then CPrint                 else
       if k = 'b' then Boo                    else
       if k = 'l' then look;
    Until(k = Esc);
  stat.f := f;
  stat.Field := Field;
  Assign(st,'SHART.DOG');
  Rewrite(st);
  Write(st,stat);
  Close(st);
END.