unit _LoadTree;

interface
uses ComCtrls, _String, SysUtils;

Procedure LoadTree(var TreeView: TTreeView; dir, sub :String);


implementation
procedure LoadTreeR(var TreeView: TTreeView; dir :String; node: TTreeNode);	Forward;

Procedure LoadTree(var TreeView: TTreeView; dir, sub :String);
var
 node:	TTreeNode;
 x:	Word;
 d:	string;
begin
  sub := delTrailing(sub, '\');
//  if TreeView = nil then exit;//TreeView := TTreeView.Create;
  TreeView.Items.Clear;
  node := TreeView.Items.Add(nil,'name');
  dir := delTrailing(dir, '\');
  node.Text := 'Root';
  LoadTreeR(TreeView, dir,node);
  d := sUpCase(SplitK3(sub,'\'));
  x:=0;
   while (x < node.Count) and (d <> '')do
    begin
       if SUpCase(node.Item[x].Text) <> d then inc(x)
       else begin
	 node := node.Item[x];
	 TreeView.Selected := node;
	 x:=0;                    
	 d := sUpCase(SplitK3(sub,'\'));
       end;
    end;
end;


procedure LoadTreeR(var TreeView: TTreeView; dir :String; node: TTreeNode);
var
  Child:	TTreeNode;
  SearchRec:	TSearchRec;
  found:	Integer;
  name:		string;
begin                      // TWin32FindData
    Found := FindFirst(dir+'\*.spl', faDirectory, SearchRec);
    name := searchrec.Name;
    while Found = 0 do
    begin
       if (SearchRec.Attr and faDirectory) > 0 then
	begin
	  dir := delTrailing(dir, '\');
	  child := TreeView.Items.AddChild(node,name);
	  LoadTreeR(TreeView, dir + '\' + name, child);
	end;
      Found := FindNext(SearchRec);
      name := searchrec.Name;
    end;
    FindClose(SearchRec);
end;


end.
