unit _LookAtPas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, _String, _Pasword, Buttons, ConstDef;

type
  TEditUsers = class(TForm)
    StringGrid1: TStringGrid;
    ChangePass: TButton;
    Delete: TButton;
    AddUser: TButton;
    BitBtn1: TBitBtn;
    procedure ChangePassClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure AddUserClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditUsers: TEditUsers;

Procedure LookAtPas;

implementation

{$R *.DFM}
procedure UpdateS;
var
  x:word;
begin
  with EditUsers.StringGrid1 do
  begin
  Cells[0, 0] := 'User name';
  Cells[1, 0] := 'Acsses level';
  RowCount := pas.NumOfUsers+1;
   for x := 1 to pas.NumOfUsers do
    begin
      Cells[0, x] := pas.GetUserNameX(x);
      Cells[1, x] := IntToStr(pas.GetPasLevX(x));
    end;
  end;

end;

Procedure LookAtPas;

begin
   if not pas.TestPasLevel(IntToStr(pas.LookAtPasLev)) then
    begin
      MessageDlg('Access denied',  mtWarning, [mbOK],0);
      exit;
    end;
  UpdateS;
  EditUsers.ShowModal;
end;



procedure TEditUsers.ChangePassClick(Sender: TObject);
begin
  pas.ChangePaswordForUser(StringGrid1.Cells[0, StringGrid1.Row]);
end;

procedure TEditUsers.DeleteClick(Sender: TObject);
begin
  pas.DeleteUser(StringGrid1.Cells[0, StringGrid1.Row]);
  UpdateS;
end;

procedure TEditUsers.StringGrid1DblClick(Sender: TObject);
var
  s:string;
  n:Longint;
begin
   if StringGrid1.Col = 0 then
    begin
      MessageDlg('Sorry can not edit the user name',
		  mtWarning, [mbCancel] ,0);
    end
   else if StringGrid1.Col = 1 then
    begin
      s := InputBox('User level', 'Input a number from 0 to 255',
			StringGrid1.Cells[1, StringGrid1.Row]);
       if MessageDlg('Write changes to password file',
		     mtConfirmation, [mbYes, mbCancel] ,0) = mrYes then
	if (AllSInK(s, '0123456789')) and (length(s) <= 3) then
	 begin
	    if length(s) = 0 then s := '0';
	   n := StrToNum(s);
	    if n > 255 then n := 255;
	   pas.SetPasLev(StringGrid1.Cells[0,StringGrid1.Row], n);
	   UpdateS;
         end
        else  MessageDlg('Error in number', mtError, [mbOK] ,0);
   end;
end;

procedure TEditUsers.AddUserClick(Sender: TObject);
begin
  pas.AddPasWord;
  UpdateS;
end;

end.
