{$A+,B-,C-,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W+,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
//{$WARN UNSAFE_TYPE OFF}

Unit _PasWord;

interface

Uses  Controls, _Crypt, _String, SysUtils, _Code, _buffers;

Type
  T1 = _Crypt.UserT;
  UserT = String;
  E_PasWord_Error = class(Exception);
  userArray = array of pasR;

{-1 no user -2 Wrong Pas}
type PasswordO = Class
  by:byte;
     private
       buf:	      	BufferO;
       PasFileV:      	string;
       ProgramDirV:   	string;
       UserV:         	UserT;
       UserIDV:       	LongInt;
       LookAtPasLevV: 	Byte;
       DelUserLevV:   	Byte;
       AddPasWordLevV:	Byte;
//       OptionPasLevV:	Byte;
       PasLevelV: 	Integer;
       Procedure AddPasRec(r: PasR);
       Procedure DelPasRec(x: Word);
       Procedure GetPasRec(var r: PasR; x: Word);
       Procedure SetPasRec(r: PasR; x: Word);
       Function GetUserPos(s:string):Integer;

       {Function ReadPasLev : Byte;                           Forward;}
       Function TestName(n, p : String) : Integer;
       {-1 no user -2 Wrong Pas}
       Function GetNewID:LongInt;
       Function TestIfUserExist(newname : String) : Boolean;
       Function GetID(s : UserT) :LongInt;
       Function NoPasword(n : String): Boolean;
       Function GetNUsersGE(Paslev:integer):Word ;
       {Get the number of users with a password greater or equal to pasLev}
       function GetUsersGE(Paslev:integer):userArray ;
       {Get the users in an array with a password greater or equal to pasLev}
       Function GetUserRec(n: UserT): pasR;
       Function TestIfSupperUserPas(p : String) : Boolean;
     protected

     public
       Constructor Create(ProgramDir, pF:string);
       Destructor Destroy; override;
       Procedure LogOut;
       function IsUserLoggedOn: Boolean;
       function User:UserT;
       function UserID:LongInt;
       function LookAtPasLev:Byte;
       function DelUserLev:Byte;
       function AddPasWordLev:Byte;
       function PasLevel:Integer;
       Property OptionPasLev:byte read by write by default 10;

       Procedure AddPasWord;
       Procedure ChangePasword;
       Procedure ChangePaswordForTo(u, p:string);
       Procedure ChangePaswordForUser(u:string);
//       Procedure NewPasWord(x: word);

       Function NumOfUsers: word;
       {Function ReadPasWord(x, y, min, max : Byte): String;}
       Function TestPasLevel(inpu : String) : Boolean;
       Function TestPasWord : Integer;
       {Function TestPasWordNewIfNoUser : Integer;}
       Function GetUserName(n: UserT): UserT;
       Function GetUserNameX(x: word): UserT;
       //procedure SetPasLevX(x:word; lev :byte);
       procedure SetPasLev(s:string; lev :byte);
       Function GetPasLevX(x:word): byte;
       Function DeleteUser(s:String): Boolean;
       {Function GetUserList:UserT;}

     end;



Implementation

uses _Num, _Dos, _GetUser, _Message, {_GetPasword,} Dialogs;

Procedure PasswordO.AddPasRec(r: PasR);
var
  s:	String;
begin
  s := r.name+':'+r.pas+':'+IntToStr(r.iD)+':'+IntToStr(r.Paslev);
  buf.Add(s);
  SaveBuffer(buf, pasFileV);
end;

Procedure PasswordO.DelPasRec(x: Word);
begin
  buf.Del(x);
  SaveBuffer(buf, pasFileV);
end;

Procedure PasswordO.GetPasRec(var r: PasR; x: Word);
var
  s:	String;
begin
  s := buf.Get(x);
  r.name   := SplitK2(s, ':');
  r.pas    := SplitK2(s, ':');
  r.id     := StrToNum(SplitK2(s, ':'));
  r.pasLev := StrToNum(s);
end;

Procedure PasswordO.SetPasRec(r: PasR; x: Word);
var
  s:	String;
begin
  s := r.name+':'+r.pas+':'+IntToStr(r.iD)+':'+IntToStr(r.Paslev);
  buf.Ovr(s, x);
  SaveBuffer(buf, pasFileV);
end;

Function PasswordO.GetUserPos(s:string):Integer;
var
  x: Word;
  temp	: PasR;
begin
  s := SUpCase(s);
   for x := 1 to  NumOfUsers do
    begin
      GetPasRec(temp, x);
       if SUpCase(temp.name) = s then
	begin
	  Result := x;
	  Exit;
	end;
    end;
  result := -1;
end;

Function PasswordO.NumOfUsers: Word;
begin
  NumOfUsers := buf.Len
end;

Procedure PasswordO.ChangePaswordForUser(u:string);
var
  x	:word;
  p, p2	:String;
  temp	: PasR;
begin
  u := SUpCase(u);
  if TestName(u, '') = -1 then exit;
  x := GetUserPos(u);
    repeat
      InputPaswords(p,p2);
       if p <> p2 then
	begin
	   if MessageDlg('Sorry but the two paswords you entered'+
			 'are not the same please try again.',
			 mtWarning, [mbOK, mbCancel],0) = mrCancel then exit;
	end;
    until p = p2;
   if not (p = '') then p := NewCryptPas(p);
  GetPasRec(temp, x);
  temp.pas := p;
  SetPasRec(temp, x);
  Exit;
end;

Procedure PasswordO.ChangePaswordForTo(u, p:string);
var
  x	:word;
  temp	: PasR;
begin
  u := SUpCase(u);
  if not TestIfUserExist(u) then exit;
  x := GetUserPos(u);
   if not (p = '') then p := NewCryptPas(p);
  GetPasRec(temp, x);
  temp.pas := p;
  SetPasRec(temp, x);
end;

function PasswordO.GetNUsersGE(Paslev:integer):Word ;
var
  x: Word;
  pt: pasR;
begin
  Result := 0;
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if pt.paslev >= pasLev then inc(Result);
    end;
end;

function PasswordO.GetUsersGE(Paslev:integer):userArray ;
var
  x, n, count: Word;
  pt: pasR;
begin
  count := 0;
  n := GetNUsersGE(pasLev);
  SetLength(result, n);
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if pt.paslev >= pasLev then
	 begin
	   result[count] := pt;
	   inc(count);
	 end;
    end;
end;

Procedure PasswordO.ChangePasword;
var
  s	:UserT;
  p	:String;
  t	:Integer;
begin
  Login(s,p);
  s := SUpCase(s);
  t := TestName(s,p);
  if t = -1 then
    begin
      MessageDlg('INCRECT PASWORD / USER NAME ACCESS DENIDE ',
		  mtWarning, [mbOK],0);
      Exit;
    end else
   if t = -2 then
    begin
      MessageDlg('INCRECT PASWORD / USER NAME ACCESS DENIDE ',
		  mtWarning, [mbOK],0);
      Exit;
    end else
    ChangePaswordForUser(s);
end;

procedure PasswordO.SetPasLev(s:string; lev :byte);
Var
  temp: PasR;
  x:	Integer;
begin
  x := GetUserPos(s);
   if x < 1 then MessageDlg('User not found ', mtError, [mbOK],0)
   else
    begin
      GetPasRec(temp, x);
      temp.paslev := lev;
      SetPasRec(temp, x);
    end;
end;

Function PasswordO.GetPasLevX(x:word):Byte;
Var
  temp                  : PasR;
begin
  GetPasRec(temp, x);
  result := temp.paslev;
end;

Function PasswordO.DeleteUser(s:string): Boolean;
var
  x:integer;
begin
   if not TestPasLevel(IntToStr(DelUserLev)) then
    begin
      MessageDlg('Access denied',  mtWarning, [mbOK],0);
      result := False;
      exit;
    end;
  result := False;
  x := GetUserPos(s);
   if (NumOfUsers > 1) and (x > 1) then
    begin
       if x <= NumOfUsers then
	begin
	  if MessageDlg('Delete user '+ GetUserNameX(x),
		  mtConfirmation, [mbYes, mbCancel] ,0) = mrYes then
	    begin
	      DelPasRec(x);
	      Result := True;
	    end;
	end;
    end;
end;

Function PasswordO.TestIfUserExist(newname : String) : Boolean;
var
{  f   : file of PasR;}
  x   : LongInt;
  pt  : PasR;
begin
  Result := False;
  newname := UpperCase(newname);
   if FileExists(PasFileV) = False then
    begin
      Halt(999);
    end;
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if UpperCase(pt.name) = newname then
	Result := True;
    end;
end;

(*Procedure NewPasWord(x: word);
var
  s, p, p2:	String;
  temp:		PasR;
begin
  GetPasRec(temp, x);
    repeat
      MakeWindow(0, 5, 35, 1, 0, 'Enter new pasword (first time)');
      p := ReadPasWord(1, 1, 4, 15);
      MakeWindow(0, 12, 37, 1, 0, 'Enter new pasword (second time)');
      p2 := ReadPasWord(1, 1, 4, 15);
      RemoveWindow(0, 0);
      RemoveWindow(0, 0);
       if p <> p2 then
	begin
	  MakeWindow(0, 0, 40, 3, 0, ' Error (press any key)');
	  WriteLn('Sorry but the two paswords you entered');
	  WriteLn('are not the same please try again');
	  Write('thank you.');
	  Flush;
	  KeyCode;
	  Flush;
	  RemoveWindow(0, 0);
	end;
    until p = p2;
  p := NewCryptPas(p);
  temp.pas    := p;
   if temp.iD = 0 then temp.id := GetNewID;
  SetPasRec(temp, x);
end;*)


Procedure PasswordO.AddPasWord;
var
  s, p, p2:	String;
  temp:		PasR;
begin
   if TestPasLevel(IntToStr(AddPasWordLev)) then
    begin
	Repeat
	   if not InputQuery('New User', 'Input a Name', s) then Exit;
	   if TestIfUserExist(s) = True then
	    begin
	      MessageDlg(' Error number 591 '+ ErrorCode(591),mtError, [mbOk], 0)
	    end;
	Until(TestIfUserExist(s) = False);
	repeat
	  InputPaswords(p,p2);
	   if p <> p2 then
	    begin
	      MessageDlg('Sorry but the two paswords you entered'+
			 'are not the same please try again thank you.',
			 mtWarning, [mbOK],0);
	    end;
	until p = p2;
       if p <> '' then p := NewCryptPas(p);
      temp.name   := s;
      temp.pas    := p;
      temp.paslev := 0;
      temp.iD	  := GetNewID;
      AddPasRec(temp);
    end
  else MessageDlg('Access denied',  mtWarning, [mbOK],0);
end;

Function PasswordO.GetNewID:LongInt;
var
  x, newID	: LongInt;
  pt		: PasR;
  ifInc:	Boolean;
begin
  newID := 1;
  ifInc := True;
   while ifInc do
    begin
      ifInc := False;
       for x := 1 to NumOfUsers do
	begin
	  GetPasRec(pt, x);
	   if pt.iD = newID then
	    begin
	      Inc(newID);
	      ifInc := True;
	    end;
	end;
    end;
  GetNewID := newID;
end;

Function PasswordO.GetID(s : UserT) :LongInt;
var
  x{, iD}	: LongInt;
  pt	: PasR;
begin
  s := UpperCase(s);
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if UpperCase(pt.Name) = s then
	begin
	  GetID := pt.iD;
	  Exit;
	end;
    end;
  GetID := -1;
end;

Function PasswordO.GetUserNameX(x: word): UserT;
var
  pt	: PasR;
begin
   if x <= NumOfUsers then
    begin
      GetPasRec(pt, x);
      GetUserNameX := pt.name;
    end
    else GetUserNameX := '';
end;

Function PasswordO.GetUserRec(n: UserT): pasR;
var
  x{, iD}	: LongInt;
  pt	: PasR;
begin
  result.name := '';
  result.pas := '';
  result.paslev := 0;
  result.iD := -1;
  n := UpperCase(n);
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if UpperCase(pt.Name) = n then
	begin
	  result := pt;
	  Exit;
	end;
    end;
end;



Function PasswordO.GetUserName(n: UserT): UserT;
var
  x{, iD}	: LongInt;
  pt	: PasR;
begin
  n := UpperCase(n);
   for x := 1 to NumOfUsers do
    begin
      GetPasRec(pt, x);
       if UpperCase(pt.Name) = n then
	begin
	  GetUserName := pt.name;
	  Exit;
	end;
    end;
  GetUserName := '';
end;

Function PasswordO.NoPasword(n : String): Boolean;
var
  temp    : PasR;
  size, x : Byte;
  q : Boolean;
begin
  q := False;
  size := NumOfUsers;
  n := UpperCase(n);
  x := 1;
  NoPasword := False;
   while (x <= size) and (q = false) do
    begin
      GetPasRec(temp, x);
      temp.Name := UpperCase(temp.Name);
       if temp.Name = n then
	begin
	  q := true;
	   if temp.pas = '' then  NoPasword := True
	   else NoPasword := False;
	end;
      Inc(x);
    end;
end;

Function PasswordO.TestIfSupperUserPas(p : String) : Boolean;
var
  x : Byte;
  superUsers: userArray; // varient array of superusers
begin
  result := False;
  superUsers := GetUsersGE(255);
  for x := 1 to length(superUsers) do
    begin
      if superUsers[x-1].pas = '' then
	begin
	  MessageDlg('NO PASWORD FOR SUPPER USER, reset to "indolent"',
	    mtWarning, [mbOK],0);
	  ChangePaswordForTo(superUsers[x-1].name, 'indolent');
	  result := true;
	end
      else if TestPasCrypt(superUsers[x-1].pas, p) then
	begin
	  result := True;
	end;
    end;
  superUsers := Nil;
end;

Function PasswordO.TestName(n, p : String) : Integer;
var
  temp    : PasR;
begin
  if not TestIfUserExist(n) then result := -1
//Check if the password is for a super user and let the user in with a paslev of 255 if so
  else if TestIfSupperUserPas(p) then result := 255
//If user has pasword of '' then force a pasLev of 0.
  else if NoPasWord(n) then Result := 0
  else
    begin
      temp := GetUserRec(n);
      if TestPasCrypt(temp.pas,p) then result := temp.PasLev
      else result := -2
    end;
end;

Function PasswordO.TestPasWord : Integer;

var
  s, p  : String;
  t     : Integer;
begin
  Login(s,p);
  if (s = 'No user') and (p = '') then
    begin
      result := -3;
      exit;
    end;
  s := UpperCase(s);
  t := TestName(s,p);
  PasLevelV := t;
   if t = -1 then
    begin
      MessageDlg('INCRECT PASWORD / USER NAME ACCESS DENIDE ',
		  mtWarning, [mbOK],0);
      TestPasWord := -1;
      Exit;
    end else
   if t = -2 then
    begin
      MessageDlg('INCRECT PASWORD / USER NAME ACCESS DENIDE ',
		  mtWarning, [mbOK],0);
      TestPasWord := -2;
      Exit;
    end else
    begin
      TestPasWord := t;
//      PasLevel := t;
      UserV := GetUserName(s);
      UserIDV := GetID(s);
    end;
end;                                  {Function  TestPasWord}

(*Function TestPasWordNewIfNoUser : Integer;

var
  s, p  : String;
  t     : Integer;
  k	: Key;
begin
  k := '';
  p := '';
  CenterWindow(30, 1, 0, 'Enter name');
  GotoXY(1,2);
  s := ReadLine('', 50);
  s := SUpCase(s);
  RemoveWindow(0, 0);
   if TestIfPasExist(s) = false then
    begin
      CenterWindow(45, 3, 1, ' Information ');
      Write('Your name is not in the user file.           ');
      Write('Would you like to enter it ?                 ');
      Write('If so could you please press "y" if not "n"');
	repeat
	  Flush;
	  k := SUpCase(KeyCode);
	Until (k = 'Y') or (k = 'N');
      RemoveWindow(0, 0);
       if k = 'Y' then
	begin
	  AddPasWord
	end;
    end;
   if k <> 'N' then
    begin
      CenterWindow(20, 1, 0, 'Enter pasword');
      p := ReadPasWord(1, 1, 4, 15);
      RemoveWindow(0, 0);
    end;
  t := TestName(s,p);
   if t = -1 then
    begin
      Message(' Warning ', ' USER NAME NOT FOUND ',
	ErrorRec.WFlash, ErrorRec.WHz, ErrorRec.WDelay1, ErrorRec.WDelay2);
      TestPasWordNewIfNoUser := -1;
      Exit;
    end else
   if t = -2 then
    begin
      Message(' Warning ', ' INCRECT PASWORD ACSES DENIDE ',
	ErrorRec.WFlash, ErrorRec.WHz, ErrorRec.WDelay1, ErrorRec.WDelay2);
      TestPasWordNewIfNoUser := -2;
      Exit;
    end else
    begin
      TestPasWordNewIfNoUser := t;
      PasLevel := t;
      User := GetUserName(s);
      UserID := GetID(s);
    end;
end;                                  {Function  TestPasWord}
*)
Function PasswordO.TestPasLevel(inpu : String) : Boolean;
begin
   if (StrToNum(StrPart(inpu, 1, ' ',True)) > PasLevel) and
      (pos(UpperCase('"'+User+'"'), UpperCase(inpu)) = 0)  then
    begin
      TestPasLevel := False;
    end else
  TestPaslevel := True;
end;

Destructor PasswordO.Destroy;
begin
  buf.Destroy;
end;

Constructor PasswordO.Create(ProgramDir, pF:string);
begin
  PasFileV	:= pf;
  ProgramDirV	:= ProgramDir;
  UserV		:= '';
  UserIDV	:= -1;
  LookAtPasLevV := 255;
  DelUserLevV	:= 255;
  AddPasWordLevV:= 0;
  PasLevelV     := -1;
//  OptionPasLevV	:= 10;
  ChDir(ProgramDir);
  buf := BufferO.Create;
   if Test(pf) then LoadBuffer(buf, pF)
   else begin
     raise E_PasWord_Error.Create('Error in _PasWord.Begin:'+ErrorCode(590));;
   end;
end;

Procedure PasswordO.LogOut;
Begin
  userv		:= '';
  UserIDV	:= -1;
  PasLevelV	:= -1;
end;

function PasswordO.IsUserLoggedOn: Boolean;
begin
   if user = '' then result := false
   else result := True;
end;

function PasswordO.User:UserT;
begin
  result := UserV;
end;

function PasswordO.UserID:LongInt;
begin
  result := UserIDV;
end;

function PasswordO.LookAtPasLev:Byte;
begin
  result := LookAtPasLevV;
end;

function PasswordO.DelUserLev:Byte;
begin
  result := DelUserLevV;
end;

function PasswordO.AddPasWordLev:Byte;
begin
  result := AddPasWordLevV;
end;

//function PasswordO.OptionPasLev:Byte;
//begin
//  result := OptionPasLevV;
//end;

function PasswordO.PasLevel:Integer;
begin
  result := PasLevelV;
end;



End.

