unit _ScoreUtils;

interface
uses
  SysUtils;
type
  scoreR = record
	     name: String;
	     score: Integer;
	     maxHelp,
	     tolalHelp,
	     total	:word;
	   end;
  E_ScoreUtils_Error = class(Exception);

//Procedure ShowScoreFile(f : String);
//procedure AddScore(f:String;r:scoreR);

implementation
uses
  _buffers, _String, _Dos, _Score, Dialogs, _Code;

(*Procedure ShowScoreFile(f : String);
var
  buf:			BufferO;
  error, x, totalN:		Word;
  percent:	Integer;
  s1, nameS, scoreS, dateS:	String;
  timeS, maxHelpS, totalS:	String;
  percentS:			String;
//  cx, cy, oldCursor:	Byte;
  label skip1;
begin
  buf.Init;
   if Test(f) = True then
    begin
      error := LoadBuffer(Buf, f);
       if error <> 0 then
	begin
	  MessageDlg(' Error loading buffer file '+
	     ErrorCode(error), mtError, [mbOk], 0);
	  buf.Done
	end;
    end;
{  HelpTopic := 'Score';}
   for x := 1 to buf.len do
    begin
      s1 := buf.Get(x);
       if InString(s1,'&') then
	begin
	  nameS := SplitK2(s1, '&');
	  dateS := SplitK2(s1, '$');
	end
	else begin
	  nameS := SplitK2(s1, '$');
	  dateS := '';
	end;
      scoreS := SplitK2(s1, ':');
      maxHelpS := SplitK2(s1, '%');
       if inString(s1, ';') then
	begin
	  totalS := SplitK2(s1, ';');
	  timeS := s1;
	end
	else begin
	  totalS := s1;
	  timeS := '';
	end;
      totalN := StrToNum(totalS);
       if totalN = 0 then totalN := 1;
      percent := round((100 / totalN) * StrToNum(scoreS));
      nameS := PadTo(nameS, #133, 51);
       if dateS <> '' then dateS := ' on the ' + dateS;
      dateS := PadTo(dateS, #46, 18);
       if timeS <> '' then timeS := '@'+timeS;
      maxHelpS := ' '+PadTo(maxHelpS, ' ', 3)+' ';
      timeS := PadTo(timeS, #46, 9);
      percentS := PadFront(IntToStr(percent),'0',3);
      scoreS := PadFront(scoreS,' ',3);
      totalS := PadTo(totalS,' ',3);
      s1 := nameS+'%'+percentS+' or '+scoreS+'/'+totalS+
	    dateS+timeS;
      buf.Ovr(s1, x);
    end;
  ShowScore(buf);
  buf.Done;
end;*)

(*procedure AddScore(f:String;r:scoreR);
var
  buf:			BufferO;
  error, x:		Word;
  x1, x2, x3:	Integer;
  Test1, test2:		Real;
  s1, t:	String;
  label skip1;
begin
  buf.Init;
   if Test(f) then
    begin
      error := LoadBuffer(Buf, f);
       if error <> 0 then
	begin
	  MessageDlg(' Error loading buffer file '+
	     ErrorCode(error), mtError, [mbOk], 0);
	  buf.Done;
	  raise E_ScoreUtils_Error.Create('Error in _ScoreUtils.AddScore:'+ErrorCode(error));;
	  exit;
	end;
    end;
  x := 1;
   if r.tolalHelp = 1 then r.maxHelp := 0;
  s1 := r.name+'&'+GetDateS+'$'+IntToStr(r.score)+':'+IntToStr(r.maxHelp)+
	'%'+IntToStr(r.total)+';'+GetTimeS;
  test1 := ((r.score- (r.maxHelp / 2)) - (r.tolalHelp / 10)
		/ r.total) * 10;
   if buf.Len < 1 then
    begin
      buf.Add(s1);
    end
   else while x <= buf.len+1 do
    begin
       if x > buf.Len then
	begin
	  buf.add(s1);
	  goto skip1;
	end
       else begin
       t := buf.get(x);
	 x1 := StrToNum(CopyFromTo(t, '$', ':', True, True));
	 x2 := StrToNum(CopyFromTo(t, ':', '%', True, True));
	 x3 := StrToNum(CopyFromTo(t, '%', ';', True, True));
	  if x3 <= 0 then x3 := 1;
	 test2 := ((x1  - x2)/ x3) * 10;
	  if (((test1 ) >= (test2)){ and (r.score > x1))
{	  or ((test1 = test2) and (x2 >= r.maxHelp))
	  or ( (test1 - r.maxHelp) > (test2 - (x2 div 2)) })then
	   begin
	     buf.Ins(s1, x);
	     goto skip1;
	   end;
	end;
      Inc(x);
    end;
skip1:
  error := SaveBuffer(Buf, f);
  buf.Done;
   if error <> 0 then
    begin
      MessageDlg(' Error saving buffer file '+
	ErrorCode(error), mtError, [mbOk], 0);
      raise E_ScoreUtils_Error.Create('Error in _ScoreUtils.AddScore:'+ErrorCode(error));;
    end;
end;*)

(*Procedure Score(f : ComStr; name :S50; sk : Integer; hl, tl: word);
var
  buf:			BufferO;
  error, x:		Word;
  x1, x2, x3, x4:	Integer;
  Test1, test2:		Real;
  addedAt:		Word;
  s1, s2, s3, oldHT:	String[100];
  cx, cy, oldCursor:	Byte;
  label skip1;
begin
  x1 := 1;
  x2 := 1;
  x3 := 1;
  buf.Init;
  addedAt := 0;
   if Test(f) = False then Open(f);
  error := LoadBuffer(Buf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
      buf.Done;
    end
    else begin
      if name = '' then
       begin
       end
       else begin
	 x := 1;
	 s1 := name+'&'+GetDateS+'$'+IntToStr(sk)+':'+IntToStr(hl)+'%'+IntToStr(tl);
	  if totellHelp = 1 then hl := 0;
	  test1 := (sk / tl) * 10;
	  if buf.Len < 1 then
	   begin
	     buf.Add(s1);
	     addedAt := buf.Len;
	   end
	  else while x <= buf.len+1 do
	   begin
	      if x > buf.Len then
	       begin
		 buf.add(s1);
		 addedAt := Buf.Len;
	       end
	      else begin
		x1 := StrToNum(CopyFromTo(buf.get(x), '$', ':', True, True));
		x2 := StrToNum(CopyFromTo(buf.get(x), ':', '%', True, True));
		x3 := StrToNum(CopyFrom(buf.get(x), '%', True, True));
		 if x3 <= 0 then x3 := 1;
		test2 := (x1 / x3) * 10;
		 if (((test1 - (hl div 2)) > (test2 - x2)) and (sk > x1))
		 or ((test1 = test2) and (x2 >= hl))
		 or ( (test1 - hl) > (test2 - (x2 div 2)) )then
		  begin
		    buf.Ins(s1, x);
		    addedAt := x;
		    goto skip1;
		  end;
	       end;
	     Inc(x);
	   end;
skip1:
{	  while buf.Len > 10 do buf.del(buf.Len);}
	 error := SaveBuffer(Buf, f);
	  if error <> 0 then
	  Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
       end
    end;
  HelpTopic := 'Score';
  MakeWindow(0, 0, 78, 10, 0, ' High Score Press Any Key ');
  cx := GetCursorX(0);
  cy := GetCursorY(0);
  error := buf.len;
   if error > 10 then error := 10;
   if error > 0 then
   for x := 1 to error do
    begin
      s1 := buf.Get(x);
      s2 := SplitK2(s1, '$');
      s3 := s2;
      s2 := SplitK2(s3, '&');
      s2 := PadTo(s2, '', 51);
      s3 := PadTo(s3, '', 10);
      x2 := StrToNum(SplitK2(s1, ':') );
      x3 := StrToNum(SplitK2(s1, '%') );
      x4 := StrToNum(s1);
       if x4 = 0 then x4 := 1;
      s1 := '%' +
	    PadFront(IntToStr(Round((100 / x4) * x2)), '0', 3) + ':'+
	    PadFront(IntToStr(x2), '', 3)+'/'+
	    PadTo(IntToStr(x4), '', 3)+':'+
	    PadFront(IntToStr(x3), '0', 2);
      s1 := PadTo(s1, '', 15);
       if x = addedAt then WriteAttr := WriteAttr xor $77;
      DrectWriteS(cx, cy+(x-1), 0, s2+s1+' @'+s3);
       if x = addedAt then WriteAttr := WriteAttr xor $77;
    end;
  flush;
  KeyLoop;
  flush;
  DelWindow(0,0);
  buf.Done;
  HelpTopic := oldHT;
  SetCursorAttr(oldCursor);
  UpdateCursor;
end;*)


end.
 