{$A+,B-,D+,E+,F+,I+,L+,N-,O-,R+,S+,V+,X+}
{$M 16384,0,655360}
unit _EditLine;

interface

uses Crt, _win2, Dos, _String, _Screen, _Delay;
Const
  inputTitle	: String[78] = 'Input';
  defaultInputTitle : String[78] = 'Input';
  StartAtBeginningOfLine : Boolean = True;
  startLinePos	: Byte	= 1;  {if fileYesNo false then LinePos = startLinePos. Then startLinePos = 1}
  lineShift	: Byte	= 0;
  linePos	: Word	= 1;
  editFilePos	: Word	= 1;
  fileLength	: Word	= 1;
  fileYesNo	: Boolean	= False;
  insert1	: Boolean = True;
  EditlineAttr	: Byte	= GreenC+BlueB+Bright;
type
  S78 = String[78];
var
  ReadLineProc1, ReadLineProc2 : Procedure;

Function GetInPutWin(x, y, maxLength : Byte; Start, KeyAllow : String) : String;
Function ReadLine(line:String; maxLength : Byte) : String;
Function ReadStr(c : Char; len : Byte): String;
Function ReadString(line:String) : String;
Function ReadYN(in1 : S78; in2 :String; blink, start : Boolean) : Boolean;

implementation

uses _Error, _KeyB, _Dos;

Const
  KeysAllow : String = '';     { for GetInPutWin }
var
  er : Word;

Procedure KeyP; { for GetInPutWin }
begin
   if Length(LastKey) > 0 then
   if (not InString(KeysAllow, lastKey[1])) or (Length(lastKey) < 1) then
    begin
      EatKey := True;
      Sound(500);
      Delay(200);
      NoSound;
    end;
end;

Function GetInPutWin(x, y, maxLength : Byte; Start, KeyAllow : String) : String;
Var
  k         : Key;
  id		:Word;
begin
  InOutZ;
  Flush;
  GetInPutWin := '';
  KeysAllow := KeyAllow;
  ReadLineProc1 := Keyp;
  MakeWindow(x, y, 40, 1, 0, inPutTitle);
  inPutTitle := defaultInputTitle;
   if InOutError then begin Exit; End;
  TextAttr := TextAttr xor $77;
  Write(start);
  TextAttr := TextAttr xor $77;
  k := NextKeyCode;
   if (k>=' ') and (k<='~') then
    begin
      Crt.ClrScr;
      startLinePos := 1;
      start := ReadLine('', maxLength);
    end else
   if k <> ret then
    begin
      Crt.ClrScr;
      startLinePos := length(start) + 1;
      start := ReadLine(start, maxLength);
    end;
  DelWindow(0, 0);
  GetInPutWin := start;
  ReadLineProc1 := Nothing;
end;

Function ReadLine(line:String; maxLength : Byte) : String;
var
  le, leSave	: key;
  x, y, ww	: Byte;
  oldlen,wd	: Byte;
  oldline	: String;
  quit		: Boolean;
  oldCursor	: Word;
  sX, sY	: Byte;
begin
  oldCursor := GetCursorSE;
  quit := False;
  oldline := line;
  ww := WindWidth(0,0);
  wd := WindDepth(0,0);
  x := WhereX;
  y := WhereY;
   if linePos < 1 then linePos := 1;
   if linePos <= lineShift then lineShift := linePos - 1;
   if StartAtBeginningOfLine then x := 1 else
    begin
       if ww - (x - 1) < 2 then
        begin
           if not wd > 1 then x := 1 else WriteLn;
        end else
      ww := ww + (x - 1);
    end;
  GotoXY(x, y);
  sX := GetCursorX(0);
  sY := GetCursorY(0);
  oldlen := length(line);
   if insert1 then
    begin
      SetCursorStartLine(4);
      SetCursorEndLine(16);
    end
    else begin
      SetCursorStartLine(1);
      SetCursorEndLine(16);
    end;
  SetCursorAttr(Normal);
  UpdateCursor;
   if fileYesNo = False then
    begin
      linePos := startLinePos;
      lineShift := 0;
       if Integer(linePos)-lineShift > ww then
	begin
	  lineShift := linePos - (ww);
	   if fileLength > 1 then quit := True;
	end;
    end;
  startLinePos := 1;
  repeat
    line := DelTrailing(line, ' ');
     if Length(line) < oldLen then line := PadTo(line, ' ', oldLen);
    DrectWriteCA(sX, sY, 0, Copy(Line,1+lineShift,ww-1), EditlineAttr);
    line := DelTrailing(line, ' ');
     if linePos <= lineShift then
      Write('Help');
    GotoXY((linePos - lineShift) + (x - 1), y);
    oldlen := length(line);
    ReadLineProc2;
    le := KeyLoop;
     if (le = ^P) or (le = ^Q) or (le = ^K) then
      begin
	leSave := le;
	le := KeyLoop;
	le := leSave + le;
	le := SUpCase(le);
      end;
     if (le = home) or (le = ^Q'S')then begin linePos:=1; end
     else if (le = left) or (le = ^S) then
      begin
	 if linePos > 1 then Dec(linePos) else
	 if editFilePos > 1 then quit := True;
      end
     else if (le = right) or (le = ^D) then
      begin
	 if linePos <= 255 then Inc(linePos);
      end
     else if le = ^Q'L' then line := oldLine
     else if (le = del) or (le = ^G) then
      begin
	 if Length(line) >= LinePos then Delete(line, linePos ,1) else
	 if fileLength > editFilePos then quit := True;
      end
     else if le = bs then
      begin
	 if linePos > 1 then
	  begin
	    Delete(line,(linePos - 1),1);
	    Dec(linePos);
	  end else
	 if editFilePos > 1 then quit := True;
      end
     else if (le = aY) or (le = ^Q^Y) then
      begin
	 if Length(line) > linePos then
	  begin
	    Delete(line,linePos, Length(line));
	    clreol;
	  end;
      end
     else if le = Ins then
      begin
	 if insert1 then
	  begin
	    insert1 := False;
	    SetCursorStartLine(1);
	    SetCursorEndLine(16);
	    UpdateCursor;
	  end
	  else begin
	    insert1 := True;
	    SetCursorStartLine(4);
	    SetCursorEndLine(16);
	    UpdateCursor;
	  end;
      end
     else if le = ^Y then
      begin
	 if fileLength <= 1 then
	  begin
	    line:='';
	    linePos:=1;
	    gotoxy(1,y);
	    clreol;
	  end else
	quit := True;
      end
     else if (le = end1) or (le = ^Q'D') then
      begin
	linePos := length(line) + 1;
{        if linePos-lineShift >= ww then lineShift := linePos - (ww + 1);}
      end
     else if (le = f2) or (le = ^k'S') then
      begin
	 if (editFilePos > 1) then quit := True;
      end
     else if (le = up) or (le = ^e) then
      begin
	 if (editFilePos > 1) then quit := True;
      end
     else if (le = Down) or (le = ^x) then
      begin
	 if (fileLength > editfilePos) then quit := True;
      end
     else if ((le = ^w) or
	      (le = ^z) or (le = cEnd) or (le = cHome) or (le = pgDn) or
	      (le = PgUp) or (le = cPgDn) or (le = cPgUp) or
	      (le = ^r) or (le = ^c)) then
      begin
	 if fileLength > 1 then quit := True;
      end
     else if (le <> ret) and (le <> esc) and (quit = False) then
      begin
	ReadLineProc1;
	 if (EatKey) or (le = '') or (le[1] = ^Q) or (le[1] = ^K) then else
	 if ((Length(line) <= (maxLength + (length(le) - 1) )) or
	     (Length(line) <= (maxLength + (length(le)) ) )
	     and (insert1 = False))
	    and (linePos < maxLength) then
	  begin
	    GotoXY(linePos - lineShift, y);
	     if le[1] = ^P then le := DelFirst(le, 1);
	     if linePos > Length(line) then line := PadTo(line, ' ', linePos-1);
	     if insert1 then Insert(le,line,linePos)
	      else begin
		 if Length(line) < linePos then line := PadTo(line, ' ', linePos);
		line[linePos] := le[1];
		 if length(le) > 1 then Insert(DelFirst(le, 1),line,linePos);
	      end;
	    linePos := linePos + length(le);
	  end
	  else begin
	    Message(' Error ', ' Max Line Length '+IntToStr(maxLength)+' ', ErrorRec.EFlash,
		      ErrorRec.EHz, ErrorRec.EDelay1, ErrorRec.EDelay2);
	    Flush;
	  end;
      end;
     if Integer(linePos)-lineShift > ww then
      begin
        lineShift := linePos - (ww);
         if fileLength > 1 then quit := True;
      end;
     if linePos <= lineShift then
      begin
        lineShift := linePos - 1;
         if fileLength > 1 then quit := True;
      end;
     if lineShift < 0 then lineShift := 0;
  until (le = ret) or (le = esc) or (quit = True);
   if le = ret then
    if linePos > Length(line) then line := PadTo(line, ' ', linePos - 1);
   if (le = Esc) and (fileYesNo = False) then ReadLine := oldline
   else ReadLine := line;
  SetCursorSE(oldCursor);
  UpdateCursor;
end;

Function ReadStr(c : Char; len : Byte): String;
var
  s	: String;
  x, y	: Byte;
  k	: Key;
begin
  x := GetCursorX(0);
  y := GetCursorY(0);
  s[0] := Char(len);
  ScrollToFit(0, s);
  s := '';
    repeat
      k := KeyCode;
       if k = Enter then
       else if (k = ^h) and (Length(s) > 1) then
	begin
	  s := DelLast(s, 1);
	  DecCursor(0, 1);
	  DrectWriteS(GetCursorX(0), GetCursorY(0), 0, ClrChar);
	end
       else if k = Esc then
	begin
	  DecCursor(0, Length(s));
	  s := '';
	end
       else if Length(s) >= len then
	begin
	  NoSound;
	  Sound(ErrorRec.EHz);
	  Delay(ErrorRec.EDelay1);
	end
       else begin
	 IncCursor(0, Length(k) );
	 s := s + k;
	 DrectWriteS(x, y, 0, StringOf(c, Length(s) ) );
       end;
    Until k = Enter;
  ReadStr := s;
end;

Function ReadString(line:String) : String;
Var
  dir, path : DirStr;
  k         : Key;
begin
  InOutZ;
  CenterWindow(40, 1, 0, '');{WindoWE(4,4,40,1,White);}
   if InOutError then begin InOut(er, 5, 301); exit; end;
  TextBackground(White);
  TextColor(Black);
  GetDir(0,dir);
  path := dir;
  Write(path);
  TextBackground(Black);
  TextColor(White);
  k := KeyLoop;
   if (k>=' ') and (k<='~') then
    begin
      Crt.ClrScr;
      path := ReadLine(k, 67);
    end else
   if k <> ret then
    begin
      Crt.ClrScr;
      path := ReadLine(path, 67);
    end;
  ReadString := path;
  DelWindow(0, 0);
end;

Function ReadYN(in1 : S78; in2 :String; blink, start : Boolean) : Boolean;
Const
  Yes = True;
  No  = False;
Const dep : Byte = 1;
var
  oldTextAttr, len : Byte;
  b                : Boolean;
  k                : Key;
begin
  InOutZ;
  oldTextAttr := TextAttr;
   if TextAttr >= 128 then TextAttr := TextAttr - 128;
   if blink = True then TextAttr := TextAttr + 128;
   if in1[0] > in2[0] then len := Length(in1) else
    begin
      len := Length(in2) + 2+ 8;
       if len > 78 then
	begin
	  dep := len mod 78 + 1;
	  len := 78;
	end;
    end;
{ DoubleFrame(True);}
  CenterWindow(len, dep, 0, in1);
   if InOutError then begin InOut(er, 5, 349); exit; end;
  GotoXY(1,1);
  Write(' ', in2, ' ', start);
  b := start;
    Repeat
      GotoXY(1, 1);
      Write(' ', in2, '        ');
      GotoXY(2, 1);
      Write(' ', in2, ' ', b);
      k := KeyCode;
       if (SUpCase(k) = 'Y') or (SUpCase(k) = 'T') then b := Yes else
       if (SUpCase(k) = 'N') or (SUpCase(k) = 'F') then b := No;
    Until (k = #13) or (k = Esc);
   if k = Esc then ReadYN := start else
  ReadYN := b;
  DelWindow(0, 0);
end;

BEGIN
  ReadLineProc1 := Nothing;
  ReadLineProc2 := Nothing;
End.
