{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V+,X+}
{ $M 12240,5000,655360}
unit Spl5;
Interface
USES _Win2, Dos, {Crt,} _KeyB, _String, _EditLine, _Dos, _Buffers, _Error,
     _JDos, _JWord, _Screen, _Code, _Num, _Menus, {_ExitProcedure, _ExitData,}
     _PasWord, _Help, _Print, _Delay;
type
  S40  =  String[40];
  S50  =  String[50];
Const
  d = 2;
  minD	= 500;
  letD	= 75;
  defaultFile = 'words0.spl';
{  defaultName:	S50 = 'Your name';}
  defaultPos:	Byte = 2;
  doFile : Boolean = False;
  inOrder : Boolean = False;
  SplDir	:ComStr = 'spl.spl\';
  SubDir	:ComStr = '';
       Function Format(var buf : BufferO;molt: Boolean):Boolean;Forward;
       Procedure Opens(f  :string);				Forward;
       Function  Red(f : ComStr; n : Word):String;		Forward;
{$F+}  Procedure Reshow;					Forward;
{$F-}  Procedure Ryrite(f      :string);			Forward;
       Procedure Score(f : ComStr; name :S50; sk : Integer; hl, tl: Word);	Forward;
       Procedure Dylete2(f :String);				Forward;
       Procedure Mane2(f : ComStr; name :S50);			Forward;
       Procedure Rite(f:string; s : String; n : Word);          Forward;

var
  CFile:		NameExtStr;
  fileP			:ComStr;
  choy:			String;
  helpDepth, x:		Word;
  totellHelp:		Word;
  {bufL, wordBuf:	BufferO;}
  debugX, WinId		:Word;

{$F+}
Procedure ErrorProc;
begin
   if TestInOutError then
    begin
      lockIO := True;
      MakeWindow(0, 0, 70, 14, 0, 'Program Error' );
      lockIO := False;
      WriteTrace;
      WriteLn;
      WriteLn('Error :', GetLastInOutError, ' = ', ErrorCode(GetLastInOutError));
      WriteLn(UnitCode(errorInUnit));
      WriteLn('Line with error :', errorLine);
      WriteLn('Press any key');
      Flush;
      ReadKey;
      Flush;
      DelWindow(0,0);
    end;
end;

Procedure SplHelp;
begin
   if LastKey = F1 then
    begin
      EatKey := True;
       if allowHelpIntr then Help;
      EatKey := True;
      Flush;
    end;
end;

Procedure Reshow;
begin
   if LastKey = F5 then
    begin
      inc(helpDepth);
      EatKey := True;
      Message('Word to enter', choy, True, 1000, 200, minD+(Length(Choy)*letD));
      Message('Information', 'Please wait', False, 0, 0, 3000);
      Flush;
    end
   else if LastKey = F1 then SplHelp;
end;
{$F-}

Procedure SaveSetup;
var
  f	:ComStr;
  buf	:BufferO;
  error	:Word;
begin
  buf.init;
  f := Filename(User)+'.DIR\SPL.CON';
   if not Test(f) then CreateFile(f);
  error := LoadBuffer(Buf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end
    else begin
      buf.Ovr(cFile, 1);
    {  Rite(uf,defaultName , 2);}
      if inOrder then buf.Ovr('1', 3) else buf.Ovr('0', 3);
      if doFile then buf.Ovr('1', 4) else buf.Ovr('0', 4);
      buf.Ovr(subDir, 5);
      error := SaveBuffer(Buf, f);
       if error <> 0 then
       Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end;
  buf.Done;
end;


Procedure PrintAllWrongWords;
var
  DirInfo:	SearchRec;
  tUser:	UserT;
begin
  tUser := GetUserList;
  FindFirst(SplDir+tUser+'.DIR\*.NAM', Archive, DirInfo);
  while DosError = 0 do
  begin
    Print(SplDir+tUser+'.DIR\'+FileName(DirInfo.Name)+'.NAM');
    FindNext(DirInfo);
  end;
end;

Function GetOwnerOf(f: ComStr): String;
var
 temp	:String;
begin
  temp := Red(FileDir(f)+FileName(f)+'.USR', 1);
   if temp = '' then temp := '(Owner not found)';
  GetOwnerOf := temp;
end;

Function SetOwnerOf(f: ComStr): String;
begin
  Rite(FileDir(f)+FileName(f)+'.USR', '"'+user+'"', 1);
end;

Function MakeRanOrderFile(f, n : ComStr): Boolean;
var
  buf{, wordBuf}:		BufferO;
  x2, bL, z, y:	Word;
  fileSize:	Word;
  f2:		ComStr;
  s:		String;
begin
  buf.Init;
  f := SUpCase(f);
  n := FileDir(f)+FileName(n)+'.DIR\';
   if not Test(f) then Exit;
   if FileExt(f) = '.NAM' then f2 := n+FileName(f)+'.PO2'
   else f2 := n+FileName(f)+'.POS';
  fileSize := fileSizeText(f);
  x := 1;
   if FileExt(f) = '.NAM' then
   begin
      Message('Information press any key',
	      'Number of words you have in the the wrong word file = '+
	      IntToStr(fileSize),
	      False, 1, 0, 0);
   end;
   if fileSize < 1 then
    begin
      Message('Error' , ' Not enough words in file ', True, 1000, 400, 1800);
      Flush;
      MakeRanOrderFile := False;
      buf.Done;
      Exit;
    end;
   for x := 1 to fileSize do buf.add(IntToStr(x));
  Randomize;
  MakeWindow(10, 12, 58, 1, 0, 'Information');
  write('Please waite while I randomize the order of sequence file');
  bL := buf.len{ - x2};
{   for debugX := 1 to buf.Len do Write(PadTo(buf.Get(debugX), '', 4));}
   for y := 1 to 5 do
   for x := 1 to buf.Len do
    begin
      z := Random(bL) + 1;
      buf.swop(x, z);
{   for debugX := 1 to buf.Len do Write(PadTo(buf.Get(debugX), '', 4));}
    end;
  DelWindow(0,0);
{   for debugX := 1 to buf.Len do Write(PadTo(buf.Get(debugX), '', 4));}
  Flush;
   if not TestDir(FileDir(f2)) then MDir(FileDir(f2));
  SaveBuffer(buf, f2);
  MakeRanOrderFile := True;
  buf.Done;
end;

Procedure Add(f : ComStr);
var
  Buf	: BufferO;
  l, s	: String;
  error	: Word;
begin
  s := IntToStr(100);
  s := s+ ' '+  GetOwnerOf(fileP);
   if TestPasLevel(s) = False then
    begin
      Message(' Message ', 'Acses denide this is not your file! ('+f+')', True, 1000, 400, 1800);
      exit;
    end;
  if Test(fileP) = False then Opens(fileP);
  l := '';
  buf.Init;
  error := LoadBuffer(Buf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
      Flush;
      buf.Done;
      Exit;
    end;
  MakeWindow(1, 5, 78, 3, 0, 'Infomation');
  Write('TYPE IN THE WORD TO ADD TO THE FILE (not more than 250 character', #39, 's'#10#13);
  GotoXY(1, 3);
  Write('Adding to file <', f, '>');
  while(l <> 'exit') do
    begin
      GotoXY(1,2);
      Write('TYPE "exit" TO QUIT', ' the size of the file is ', buf.Len,#10#13);
      l := GetInPutWin(10, 12, 255, 'exit', AToz+' .,?-''');
      l := DelLT(l, ' ', ' ');
       if (l <> 'exit') and (l <> '') then
	begin
	  buf.Add(l);
	  if TestInOutError then
	  Message(' Error adding to buffer ', ErrorCode(GetLastInOutError),
		  True, 1000, 400, 1800);
	end;
    end;
  removeWindow(0, 0);
   error := SaveBuffer(Buf, f);
   if error <> 0 then
    Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
  buf.Done;
  Flush;
end;

Procedure opens(f : string);
    var
      f2     : Text;
      cmd1   : string;
begin
  Flush;
   if ReadYN('Input', f+' not found crate new', False, True) then
    begin
      CreateFile(f);
       if Test(f) then exit;
    end;
  Message(' Message ', 'can not continue with out '+f,
	  True, 1000, 400, 5000);
  Halt(9);
end;

Procedure Rite(f:string; s : String; n : Word);
var
  w : Text;
  buf : BufferO;
  error	: Word;
begin
   if (Test(f)) = False then
    begin
      Opens(f);
    end;
  buf.Init;
  error := LoadBuffer(Buf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end
    else begin
      buf.Ovr(s,n);
       if TestInOutError then
       Message(' Error adding to buffer ', ErrorCode(GetLastInOutError),
	       True, 1000, 400, 1800);
      error := SaveBuffer(Buf, f);
       if error <> 0 then
       Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end;
  buf.Done;
end;

Procedure Dylete(f,f2 :String);
begin
  Dylete2(f);
  Dylete2(f2);
end;

Procedure Dylete2(f :String);

var
  f2:	file of String;
  st:	String;
begin
  st := '';
  ClrScreen(0);
  GotoXY(1,1);
  Assign(f2, f);
  {$I-}
  Reset(f2);
  {$I+}
   if IOResult <> 0 then
    begin
      WriteLn('Cannot find ', f);
      Delay(3000);
    end else
    begin
      Close(f2);
      WriteLn('Delete ', f, '? yes/no');
      ReadLn(st);
      st := SUpCase(st);
       if st = 'YES' then
	begin
	  WriteLn('Deleting ', f);
	  Delay(3000);
	  Erase(f2);
	end;
    end;
  ClrScreen(0);
  GotoXY(1,1);
end;

Procedure WMane;
var
  f:	ComStr;
  b  : Longint;
begin
  ClrScreen(0);
  GotoXY(1,1);
  f := DelAllK(User, '. ');
  f := Filename(User)+'.DIR\'+FileName(fileP)+'.NAM';
   if Test(f) = False then
    begin
      Message('Message', 'FILE NOT FOUND ('+f+')', False, 1, 0, 0);
      Flush;
      Exit;
    end;
  b := FileSizeText(f);
   if b < 1 then
    begin
      Message('Error press any key', 'Not enough words in file <'+f+'>' , False, 1, 0, 0);
      exit;
    end;
  mane2(f, User)
end;


Procedure mane(f : string);
var
  b  : Longint;
begin;
{  ClrScreen(0);}
  GotoXY(1,1);
   if Test(f) = False then
    begin
      Message('Error press any key', 'File not found <'+f+'>' , false, 1, 0, 0);
      Exit;
    end;
  b := FileSizeText(f);
   if b < 1 then
    begin
      Message('Error press any key', 'Not enough words in file <'+f+'>' , False, 1, 0, 0);
      exit;
    end;
  Message(' MESSAGE ',
	  'Press any key when you are ready', False, 1, 0, 0);
  Mane2(f,User);
end;

Procedure Mane2(f : ComStr; name :S50);
var
  x, bufIn, words, WScoreID:	Word;
  t:				Integer;
  innput:			String;
  fn:				ComStr;
  error,helpDepthG, totellHelp:	Word;
  wordBuf, buf, bufDel:		BufferO;
  keyProcOld:			Procedure;
  OldwriteScroll		:Boolean;
  label repy, Quit;
begin      { begining of procedure mane2}
  keyProcOld := KeyProc1;
  InOutZ;
  wordBuf.Init;
  buf.Init;
  bufDel.Init;
  SUpCase(f);
  helpDepthG := 0;
  totellHelp := 0;
  wordBuf.Done;
  error := LoadBuffer(wordBuf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
      wordBuf.Done;
      Exit;
    end;
   if not Format(wordBuf, SUpCase(FileExt(f)) = '.NAM') then{}
   SaveBuffer(wordBuf, f);
  t := 0;
  innput := '';
  helpDepth := 0;
  MakeWindow(12, 6, 55, 1, 0, '');
  Write('If you want a second look press F5. (you loose points)');
  Border := False;
  WScoreID := MakeWindow(2, 24, 70, 1, 0, 'Score');
  Border := True;
   if doFile then words := wordBuf.len
    else begin
      words := 10;
      if test(Filename(name)+'.DIR\'+FileName(f)+'.POS') then
       begin
	   error := LoadBuffer(Buf, Filename(name)+'.DIR\'+FileName(f)+'.POS');
	   if error <> 0 then
	    begin
	      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
	      buf.Done;
	      wordBuf.Done;
	      Exit;
	    end;
	end;
    end;
   for x := 1 to words do
    begin
      {delPos[x] := 0;}
       if inOrder then
	begin
	  choy := wordBuf.Get(x);
	  bufIn := x;
	end
	else begin
	   if buf.len < 1 then
	    begin
	      MakeRanOrderFile(f,name);
	      error := LoadBuffer(Buf, FileDir(f)+Filename(name)+'.DIR\'+FileName(f)+'.POS');{??}
	       if error <> 0 then
		begin
		  Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
		  buf.Done;
		  wordBuf.Done;
		  Exit;
		end;
	    end;
	  bufIn := StrToNum(buf.get(1));
	  choy := wordBuf.Get(bufIn);
	  buf.del(1);
	end;
repy:
      Message('Word to enter', choy, false, 1000, 200, MinD+(Length(choy) * LetD));

      OldwriteScroll := writeScroll;
      writeScroll := false;
      WWrite(1, 1, 0, 0,
      PadTo('Hi score '#174+IntToStr(words - t)+' '#175' '+
			    IntToStr(words - x)+' go'#39's left out of '+
			    IntToStr(words)+' words', ' ', 68) );
      writeScroll := OldwriteScroll;
      Delay(1000);
      SoundFor(600, 200);
	repeat
	  flush;
	  helpDepth := 0;
	  KeyProc1 := Reshow;
	  innput := GetInPutWin(0, 0, 255, '', AToz+' .,?!-''');
	  KeyProc1 := KeyProcOld;
	   if helpDepth > helpDepthG then helpDepthG := helpDepth;
	  totellHelp := totellHelp + helpDepth;
	until innput <>  '';
       if innput = 'exit' then
	begin
	 RemoveWindow(WScoreID,0);
	 DelWindow(0,0);
	 Score(FileDir(f)+FileName(f)+'.SCO', name, (x-1) - t, helpDepthG, x );
	  Goto Quit;
	end;
       if choy = innput then
	begin
	  Message(' Message ', 'RIGHT !!', False, 0, d * 500, 0);
	   if FileExt(f) = '.NAM' then bufDel.Add(IntToStr(x));
	end else
        begin
	  t := t + 1;
	  SoundFor(400, 1000);
	  Message(' PLEASE PRESS ENTER WHEN READY ',
		  'WRONG IT IS "'+choy+ '"'#10'      NOT: "'+ innput+'"', False, 1, 0, 0);
	   if SUpCase(FileExt(f)) = '.SPL' then
	    begin
	      fn := DelAllK(name, '. ');
	      fn := Filename(name)+'.DIR\'+FileName(f)+'.NAM';
	       if Test(fn) = False then Opens(fn);
	       if choy <> 'exit' then Rite(fn, choy, FileSizeText(fn)+1);
	    end
	    else if SUpCase(FileExt(f)) = '.NAM' then wordBuf.add(choy);
	  goto repy;
        end;
    end;
  RemoveWindow(WScoreID,0);
  DelWindow(0,0);
   if SUpCase(FileExt(f)) = '.SPL' then Score(FileDir(f)+FileName(f)+'.SCO', name, words - t, helpDepthG, words)
   else if FileExt(f) = '.NAM' then
    begin
       for x := 1 to bufDel.Len do wordBuf.Ovr(' ', StrToNum(bufDel.Get(x)));
      Format(wordBuf, true);
      error := SaveBuffer(wordBuf, f);
       if error <> 0 then
       Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end;
   if SUpCase(FileExt(f)) = '.NAM' then wordBuf.Ovr(' ', bufIn);
   error := SaveBuffer(Buf, Filename(name)+'.DIR\'+FileName(f)+'.POS');
    if error <> 0 then
    Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
Quit:
  wordBuf.Done;
  buf.Done;
  bufDel.Done;
end;

Procedure Ryrite(f      :string);
var
  reed   : string;
  f2     : file of string ;

begin
  reed := '';
  ClrScreen(0);
  GotoXY(1,1);
  WriteLn('ARE YOU SURE YOU WHANT TO DELETE THE CONTENTS OF <', f, '> yes!\no');
  ReadLn(reed);
   if reed <> 'yes!' then exit ;
  Assign(f2, f);
  Rewrite(f2);
  Close(f2);
end;

Procedure Edit(f :String);
var
  edit:		WordBufferO;
  s:		String;
  oldHT:	String[100];
begin
  oldHT := HelpTopic;
  s := IntToStr(200);
  s := s+ ' '+  GetOwnerOf(fileP);
   if TestPasLevel(s) = False then
    begin
      HelpTopic := 'Access denied';
      Message(' Message Press any key', 'Access denied this is not your file! <'+f+'>.'+
	      #10'The owner is :'+GetOwnerOf(fileP), False, 1, 0, 0);
      HelpTopic := oldHT;
      exit;
    end;
  CenterWindow(32, 20, 0, ' Edit ');
   if Test(f) = False then Opens(f);
  Edit.Init;
   if edit.Install(f) Then
    begin
      edit.WriteInfoTo(25, 23);
      HelpTopic := 'Edit';
      edit.Edit(40);
      HelpTopic := oldHT;
       if not edit.UpDated then
       if ReadYN('Information', 'Save Change''s', False, True) then
	begin
	  Format(edit.buf, false);
	  edit.Save;
	end;
    end;
  edit.Done;
  DelWindow(0,0);
end;

Function Format(var buf : BufferO; molt: Boolean):Boolean;
var
  x : Word;
  s:	String;
begin
  Format := True;
  buf.sort;
  x := 1;
   while x <= buf.Len do
    begin
{$B-}
      s := buf.get(x);
       if (s[1] = ' ') and (Length(s) >= 1) then
	begin
	  Format := False;
	  s := DelLeading(s, ' ');
	  buf.Ovr(s, x);
	end;
       if (s[length(s)] = ' ') and (Length(s) >= 1) then
	begin
	  Format := False;
	  s := DelTrailing(s, ' ');
	  buf.Ovr(s, x);
	end;
       if s = '' then
	begin
	  Format := False;
	  buf.del(x);
	end
       else if (x < buf.Len) and (buf.get(x) = buf.get(x + 1)) then
	begin
	   if molt then Inc(x)
	    else begin
	      Format := False;
	      buf.del(x);
	    end;
	end
       else Inc(x);
    end;
end;

		{ above here no Words*.* }

Function Sthart : String;
var
  uf:	ComStr;
  f:	Text;
  r:	Char;
  error:	Word;
  buf:	BufferO;
begin
  buf.init;
  uf := Filename(User)+'.DIR\SPL.CON';
   if test(uf) = False then
    begin
      WriteLn('can not fine the start up file create new y /n');
      r := ReadKey;
       if 'Y' <> UpCase(r) then
	begin
	  WriteLn('can not continue with out start up file');
	  Halt(0);
	end;
       if 'Y' = UpCase(r) then
	begin
	  CreateFile(uf);
	  buf.Ovr('WORDS0.SPL', 1);
	  buf.Ovr('Your name', 2);
	  buf.Ovr('0', 3);
	  buf.Ovr('1', 4);
	  buf.Ovr('', 5);
	  error := SaveBuffer(Buf, uf);
	   if error <> 0 then
	   Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
	  buf.Done;
	end;
    end;
  error := LoadBuffer(Buf, uf);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
    end
    else begin
      if buf.Len > 0 then Sthart := FileName(buf.Get(1))+ '.SPL';
      if buf.Len > 1 then {defaultName := buf.Get(2)};
      if (buf.Len > 2) and
      (buf.Get(3) = '1') then inOrder := True else inOrder := False;
      if (buf.Len > 3) and
      (buf.Get(4) = '1') then doFile := True else doFile := False;
      if (buf.Len > 4) then subDir := buf.get(5);
    end;
  buf.Done;
end;

Procedure Score(f : ComStr; name :S50; sk : Integer; hl, tl: word);
var
  buf:			BufferO;
  error, x:		Word;
  x1, x2, x3, x4:	Integer;
  Test1, test2:		Real;
  addedAt:		Word;
  s1, s2, s3, oldHT:	String[100];
  cx, cy, oldCursor:	Byte;
  label skip1;
begin
  x1 := 1;
  x2 := 1;
  x3 := 1;
  buf.Init;
  addedAt := 0;
  oldHT := HelpTopic;
  oldCursor := GetCursorAttr;
  SetCursorAttr(invisable);
  UpdateCursor;
   if Test(f) = False then Open(f);
  error := LoadBuffer(Buf, f);
   if error <> 0 then
    begin
      Message(' Error loading buffer ', ErrorCode(error), True, 1000, 400, 1800);
      buf.Done;
    end
    else begin
      if name = '' then
       begin
       end
       else begin
	 x := 1;
	 s1 := name+'&'+GetDateS+'$'+IntToStr(sk)+':'+IntToStr(hl)+'%'+IntToStr(tl);
	  if totellHelp = 1 then hl := 0;
	  test1 := (sk / tl) * 10;
	  if buf.Len < 1 then
	   begin
	     buf.Add(s1);
	     addedAt := buf.Len;
	   end
	  else while x <= buf.len+1 do
	   begin
	      if x > buf.Len then
	       begin
		 buf.add(s1);
		 addedAt := Buf.Len;
	       end
	      else begin
		x1 := StrToNum(CopyFromTo(buf.get(x), '$', ':', True, True));
		x2 := StrToNum(CopyFromTo(buf.get(x), ':', '%', True, True));
		x3 := StrToNum(CopyFrom(buf.get(x), '%', True, True));
		 if x3 <= 0 then x3 := 1;
		test2 := (x1 / x3) * 10;
		 if (((test1 - (hl div 2)) > (test2 - x2)) and (sk > x1))
		 or ((test1 = test2) and (x2 >= hl))
		 or ( (test1 - hl) > (test2 - (x2 div 2)) )then
		  begin
		    buf.Ins(s1, x);
		    addedAt := x;
		    goto skip1;
		  end;
	       end;
	     Inc(x);
	   end;
skip1:
{	  while buf.Len > 10 do buf.del(buf.Len);}
	 error := SaveBuffer(Buf, f);
	  if error <> 0 then
	  Message(' Error saveing buffer ', ErrorCode(error), True, 1000, 400, 1800);
       end
    end;
  HelpTopic := 'Score';
  MakeWindow(0, 0, 78, 10, 0, ' High Score Press Any Key ');
  cx := GetCursorX(0);
  cy := GetCursorY(0);
  error := buf.len;
   if error > 10 then error := 10;
   if error > 0 then
   for x := 1 to error do
    begin
      s1 := buf.Get(x);
      s2 := SplitK2(s1, '$');
      s3 := s2;
      s2 := SplitK2(s3, '&');
      s2 := PadTo(s2, '', 51);
      s3 := PadTo(s3, '', 10);
      x2 := StrToNum(SplitK2(s1, ':') );
      x3 := StrToNum(SplitK2(s1, '%') );
      x4 := StrToNum(s1);
       if x4 = 0 then x4 := 1;
      s1 := '%' +
	    PadFront(IntToStr(Round((100 / x4) * x2)), '0', 3) + ':'+
	    PadFront(IntToStr(x2), '', 3)+'/'+
	    PadTo(IntToStr(x4), '', 3)+':'+
	    PadFront(IntToStr(x3), '0', 2);
      s1 := PadTo(s1, '', 15);
       if x = addedAt then WriteAttr := WriteAttr xor $77;
      DrectWriteS(cx, cy+(x-1), 0, s2+s1+' @'+s3);
       if x = addedAt then WriteAttr := WriteAttr xor $77;
    end;
  flush;
  KeyLoop;
  flush;
  DelWindow(0,0);
  buf.Done;
  HelpTopic := oldHT;
  SetCursorAttr(oldCursor);
  UpdateCursor;
end;

Procedure Dir1;
var
  buf	: GetFileO;
  temp:	ComStr;
begin
  buf.Init;
  Buf.SetDir(SplDir, SubDir+'*.spl');
  CenterWindow(56, 15, 0, ' *.spl File''s ');
  temp := buf.GetFile;
  buf.Done;
  DelWindow(0,0);
   if temp <> '' then
    begin
      cFile := FileNameExt(temp);
      subDir := FileDir(temp);
      fileP := splDir+subDir+cFile;
    end;
   if cFile = '' then
    begin
      cFile := 'words0.spl';
      subDir := '';
      fileP := splDir+subDir+cFile;
    end;
  subDir := SUpCase(subDir);
  cFile := SUpCase(cFile);
  fileP := SUpCase(fileP);
end;

Procedure MakeDir;
var
  temp :nameStr;
begin
  temp := GetInPutWin(0, 0, 8, '', atoZ+'_');
  {$I-}
  MkDir(temp);
  if IOResult <> 0 then
    WriteLn('Cannot create directory')
  else
    WriteLn('New directory created');
end;

Procedure RemoveDir;
var
  temp :nameStr;
begin
  temp := GetInPutWin(0, 0, 8, '', atoZ+'_');
  RmDir(temp);
  if IOResult <> 0 then
    WriteLn('Cannot remove directory')
  else
    WriteLn('directory removed');
end;

Procedure CopyFile;
var
  buf	: GetFileO;
  temp, temp2:	ComStr;
begin
  buf.Init;
  Buf.SetDir(SplDir, SubDir+'*.spl');
  CenterWindow(56, 15, 0, ' File to copy? ');
  temp := buf.GetFile;
  buf.Done;
  DelWindow(0,0);
   if temp = '' then exit;
  buf.Init;
  buf.SetWriteable(True);
  Buf.SetDir(SplDir, SubDir+'*.spl');
  CenterWindow(56, 15, 0, ' File to copy to? ');
  temp2 := buf.GetFile;
  buf.Done;
  DelWindow(0,0);
   if temp2 = '' then exit;
   if FileName(temp2) = '*newfile' then
    begin
      inputTitle := 'Enter new file name';
      temp2 := FileDir(temp2) + GetInPutWin(0, 0, 8, '', AtoZ+c0to9)+'.SPL';
    end;
   if temp2 = '' then exit;
  _Dos.copyFile(SplDir+temp, SplDir+temp2);
end;

Procedure ChangeDir;
var
  buf	: GetDirO;
  temp:	ComStr;
begin
  buf.Init;
  buf.SetDir(SplDir, SubDir+'*.spl');
  CenterWindow(56, 15, 0, 'Directory''s');
  temp := buf.GetDir;
  DelWindow(0,0);
   if temp <> '' then
    begin
      cFile := DefaultFile;
      subDir := FileDir(temp);
      fileP := splDir+subDir+cFile;
    end;
   if cFile = '' then
    begin
      cFile := DefaultFile;
      subDir := '';
      fileP := splDir+subDir+cFile;
    end;
  buf.Done;
  subDir := SUpCase(subDir);
  cFile := SUpCase(cFile);
  fileP := SUpCase(fileP);
end;

Function GetFileName(s : ExtStr):String;
var
  Name : string;
begin
  MakeWindow(0, 5, 60, 1, 0, ' Information ');
  Write('Please enter the name of the file you would like to create');
  name := GetInPutWin(0, 0, 50, '', AToz+c0To9);
  DelWindow(0,0);
  name := DelAllK(name, '. ');
  GetFileName := splDir+FileName(name)+'.'+s; {??}
end;

Function Red(f : ComStr; n : Word):String;
var
  Buf : BufferO;
begin
  buf.Init;
  if LoadBuffer(buf, f) <> 0 then DosE;
   if (buf.Len >= n) and (n > 0) then Red := buf.Get(n)
   else Red := '';
  buf.Done;
end;

Procedure DelScore;
var
  s: String;
begin
  s := IntToStr(200);
  s := s+ ' '+  GetOwnerOf(fileP);
  if TestPasLevel(s) then Dylete2(FileDir(fileP)+FileName(fileP)+'.SCO');
end;

Procedure DelFile1;
var
  s: String;
  buf	: GetFileO;
  temp, temp2:	ComStr;
begin
  s := IntToStr(200);
  s := s+ ' '+  GetOwnerOf(fileP);
  if TestPasLevel(s) then
   begin
     buf.Init;
     Buf.SetDir(splDir, subDir+'*.spl');
     CenterWindow(56, 15, 0, ' *.spl File''s ');
     temp := splDir+buf.GetFile;
     temp := SUpCase(temp);
     DelWindow(0,0);
      if temp = '' then ;
      if temp = fileP then
       begin
	 Message('Information', 'Can not delete the file you are using', False, 0, 0, 3000);
	 Exit;
       end;
     buf.Done;
     DelFile(FileDir(temp)+FileName(temp)+'.SCO');
     DelFile(FileDir(temp)+FileName(temp)+'.USR');
     DelFile(FileDir(temp)+FileName(temp)+'.SPL');
      for x := 1 to NumOfUsers do
       begin
	 temp2 := GetUserNameX(x);
	 DelFile(FileName(temp2)+'.DIR\'+ FileName(temp)+'.POS');{??}
       end;
   end;
end;

Procedure NewFile;
var
  s: String;
  oldFileP: ComStr;
begin
  s := IntToStr(0);
   if TestPasLevel(s) then
    begin
      oldFileP := FileP;
      cFile := GetFileName('SPL');
      cFile := SUpCase(cFile);
      fileP := splDir+subDir+cFile;
       if Test(fileP) then
	begin
	  Message('Error', ' File already exists '+fileP, True, 1000, 400, 1800);
	  cFile := FileNameExt(oldFileP);
	  filep := OldFileP
	end
	else begin
	  SetOwnerOf(fileP);
	  Add(fileP);
	end;
    end;
{  if TestPasLevel(s) then Dylete2(FileName(cFile)+'.SCO');}
end;

Procedure Directory;
const
  StartPos : word = 1;
var
  n	:Word;
  oldHT	:String;
begin
    repeat
      CenterWindow(18, 7, 0, 'File menu');
      Write('Make dir          ');
      Write('Change dir        ');
      Write('Remove dir        ');
      Write('move Dir          ');
      Write('moVe file         ');
      Write('coPy Dir          ');
      Write('cOpy File        ');
      MenuBar.add('Sorry this function is not implemented yet');
      MenuBar.add('Change working Directory');
      MenuBar.add('Sorry this function is not implemented yet');
      MenuBar.add('Sorry this function is not implemented yet');
      MenuBar.add('Sorry this function is not implemented yet');
      MenuBar.add('Sorry this function is not implemented yet');
      MenuBar.add('Copy a file');
      Flush;
      oldHT := HelpTopic;
      HelpTopic := 'File Menu';
       Repeat
	n := BarCursor2(1, 18, 1, 7, StartPos, 'mcrdvpo' );
       Until n < 256;
       if (n > 0) and (n < 8) then StartPos := n;
      HelpTopic := oldHT;
      DelWindow(0,0);
      MenuBar.Clr;
	    if n = 1  then MakeDir
       else if n = 2  then ChangeDir
       else if n = 3  then RemoveDir
       else if n = 4  then StartPos := 4
       else if n = 5  then StartPos := 5
       else if n = 6  then StartPos := 6
       else if n = 7  then CopyFile;
       if n <> 0 then
	begin
	  WWrite(1, 3, WinId, 0, PadTo('Current file that Spl5 is using is '+subDir+cFile, desktopC, 70));
	  WWrite(1, 4, WinId, 0, 'Current file length is '+IntToStr(FileSizeText(fileP))+' words long      ');
	end;
    until n = 0;
end;

Procedure FileMenu;
var
  n:		Word;
  oldHT:	String;
begin
{    repeat}
      CenterWindow(18, 11, 0, 'File menu');
      Write('dir of Files      ');
      Write('Add words         ');
      Write('Edit              ');
      Write('delete Score      ');
      Write('deleTe file       ');
      Write('New file          ');
      Write('new Order file    ');
      Write('Print file        ');
      Write('print Wrong words ');
      Write('aLl wrong file''s  ');
      Write('Directory...');
      MenuBar.add('Dir of *.spl file''s');
      MenuBar.add('Add word''s to file ('+subDir+cFile+')');
      MenuBar.add('Edit file ('+subDir+cFile+')');
      MenuBar.add('DELETE SCORE FILE FOR ('+subDir+cFile+')');
      MenuBar.add('DELETE FILE ('+subDir+cFile+')');
      MenuBar.add('Use to create new spling list File');
      MenuBar.add('Make new random order file');
      MenuBar.add('Print file <'+cFile+'>');
      MenuBar.add('Print file <'+FileName(cFile)+'.NAM> for user <'+User+'>');
      MenuBar.add('Print all the Wrong Word files for user User');
      MenuBar.add('Directory menu');
      Flush;
      oldHT := HelpTopic;
      HelpTopic := 'File Menu';
       Repeat
	n := BarCursor2(1, 18, 1, 11, 1, 'faestnopwld' );
       Until n < 256;
      HelpTopic := oldHT;
      DelWindow(0,0);
      MenuBar.Clr;
	    if n = 1  then Dir1
       else if n = 2  then Add(FileP)
       else if n = 3  then Edit(FileP)
       else if n = 4  then DelScore
       else if n = 5  then DelFile1
       else if n = 6  then NewFile
       else if n = 7  then Dylete2(FileName(cFile)+'.POS'){update}
       else if n = 8  then Print(cFile)
       else if n = 9  then Print(user+'.DIR'+subDir+FileName(cFile)+'.NAM')
       else if n = 10 then PrintAllWrongWords
       else if n = 11 then Directory;
{    until n = 0;}
end;


Procedure PaswordSetup;
const
  deftPos: Byte = 1;
var
  n:	Word;
begin
  repeat
{    DrectWriteS(2, 5, 0, 'Current user is:"'+user+'"');}
    CenterWindow(16, 3, 0, 'Pas Word Menu');
    Write('Add Pasword     ');
    Write('Edit Paswords   ');
    Write('Change pasword');
    MenuBar.add('Add pasword');
    MenuBar.add('Edit pasword file');
    MenuBar.add('Change your pasword');
    Flush;
     Repeat
      n := BarCursor2(1, 16, 1, 3, deftPos, 'aec');
     Until n < 256;
    deftPos := n;
    DelWindow(0,0);
    MenuBar.Clr;
     if      n = 1  then AddPasword
     else if n = 2  then LookAtPas
     else if n = 3  then ChangePasword;
  until (n = 0) or (n = 13);
end;


Procedure Options;
const
  deftPos: Byte = 1;
var
  n:	Word;
  oldHT:	String;
Begin
  repeat
    CenterWindow(16, 2, 0, ' Options ');
     if inOrder then Write('dO file in order')
     else Write('use random Order');
     if doFile then Write('do inTier file ')
     else Write('do Ten words  ');
    MenuBar.add('Select whether to do word list in list order or to use a random order file');
    MenuBar.add('Select whether to do entire list of words or ten');
    Flush;
    oldHT := HelpTopic;
    HelpTopic := 'Options Menu';
     Repeat
      n := BarCursor2(1, 16, 1, 2, deftPos, 'ot');
     Until n < 256;
    deftPos := n;
    HelpTopic := oldHT;
    DelWindow(0,0);
    MenuBar.Clr;
	  if n = 1 then InVertBoolean(inOrder)
     else if n = 2 then InVertBoolean(doFile);
  until n = 0;
end;


var
  n		: Word;
  mi2, re, oldHT	: string;
  cexit			: Char;
label st;

BEGIN

  WriteLn(MemAvail, ' bytes available');
  WriteLn('Largest free block is ',
	  MaxAvail, ' bytes');

  flush;
  repeat
  until keypressed;

  writeScroll := false;
  HelpFile := 'SPL5.HLP';
  PF       := 'jsys1.jsy';
  KeyProc1 := SplHelp;
  TextMode(CO80);
  TextAttr := BlueB+GreenC+Bright;
  AddPasWordLev := 100;
  fillA := BlueB;
  fillC := ' ';
  InOutProc := ErrorProc;
  ClrChar := '';
  ClrAttr := CyanB;
  desktopC := '';
  desktopA := BlueB + LightBlueC{ClrAttr};
  WriteAttr := YellowC;
  SetFrameAttr(normFrameAttr);
  ClrScreen(0);
  fillC := ' ';
  GotoXY(1,1);
  cfile := 'Words0.spl';
  subDir := '';
  SoundFor(1000, 200);
  SoundFor(2000, 500);
  NoSound;           { Relief! }
{  Score(subDir+FileName(cFile)+'.SCO','', 0, 0, 0);}
{  repeat}
    repeat until TestPasWord >= 0;
  cFile := Sthart;
  fileP := splDir+subDir+cFile;
  Border := False;
  WinId := MakeWindow(2, 2, 70, 4, 0, 'Score');
  Border := True;
  WWrite(1, 1, 0, 0, PadTo('Spl5 a program by Joseph Merlin Nathan Chamness', desktopC, 70));

    repeat
{      ClrScreen(0);}
      WWrite(1, 2, 0, 0, PadTo('Current user is:"'+user+'"', desktopC, 70));
      WWrite(1, 3, WinId, 0, PadTo('Current file that Spl5 is using is '+subDir+cFile, desktopC, 70));
      WWrite(1, 4, WinId, 0, PadTo('Current file length is '+IntToStr(FileSizeText(fileP))+' words long', desktopC, 70));
      CenterWindow(16, 8, 0, ' Main Menu ');
      Write('EXIT      (Esc) ');
      Write('Go              ');
      Write('go Wrong list   ');
      Write('Score           ');
      Write('File...         ');
      Write('Options...      ');
      Write('Pasword setup...');
      Write('Quit');
      MenuBar.add('New user ');
      MenuBar.add('Start on file ('+subDir+cFile+')');
      MenuBar.add('Go word''s you got wrong');
      MenuBar.add('Look at the score file for ('+subDir+cFile+')');
      MenuBar.add('File menu');
      MenuBar.add('Options menu');
      MenuBar.add('Pasword setup menu');
      MenuBar.add('Quit Spl5 ');
      Flush;
      if defaultPos > 4 then defaultPos := 2;
      oldHT := HelpTopic;
      HelpTopic := 'Main Menu';
       Repeat
	n := BarCursor2(1, 16, 1, 8, defaultPos, #27'gwsfopq' );
       Until n < 256;
      HelpTopic := oldHT;
      DelWindow(0,0);
      defaultPos := n;
      MenuBar.Clr;
      mi2 := splDir+subDir+FileName(cFile)+'.SCO';
       if n = 1 then
	begin
	  SaveSetup;
	   while TestPasWord < 0 do;
	  cFile := Sthart;
	end
       else if n = 2 then Mane(fileP)
       else if n = 3 then WMane
       else if n = 4 then score(mi2, '', 0, 0, 0)
       else if n = 5 then FileMenu
       else if n = 6 then Options
       else if n = 7 then PaswordSetup
       else if n = 8 then
    until (n = 0) or (n = 8);
(*    ClrScreen(0);
    CenterWindow(22, 1, 0, ' Prompt ');
    Write(' EXIT SPL4.EXE Y/N');
{    TextMode(CO40);
    LowVideo;
    TextMode(CO80);}
    cexit := UpCase(ReadKey);
    RemoveWindow(0,0)
  until 'Y' = cexit;*)
  SaveSetup;
  ClrChar := ' ';
  ClrAttr := WhiteC;
  ClrScreen(0);
END.